//############################################################################
// 
// Secure Api Class by Hazzard
//
// Function:			Not secured Api calls:
// CloseHandle:			NtClose
// GetCurrentProcess:	-
// GetCurrentProcessId	-
// GetCurrentThread		-
// GetCurrentThreadId	-
// GetModuleHandle		-
// GetModuleFileName	-
// GetProcessHeap		-
// GetProcAddress		-
// GetVersion			-
// HeapAlloc			RtlAllocateHeap
// HeapReAlloc			RtlReAllocateHeap
// HeapFree				RtlFreeHeap
// IsBadReadPtr			VirtualQuery
// IsBadWritePtr		VirtualQuery
// LoadLibrary			RtlAnsiStringToUnicodeString,LdrLoadDll,RtlFreeUnicodeString
// MapViewOfFile:		-
// MapViewOfFileEx		NtMapViewOfSection
// Module32FirstW		-
// Module32First		-
// Module32NextW		-
// Module32Next			-
// NtCurrentTeb			-
// OpenProcess:			NtOpenProcess
// OpenThread:			NtOpenThread
// Process32First		-
// Process32FirstW		-
// Process32Next		-
// Process32NextW		-
// ReadProcessMemory:	NtReadVirtualMemory
// TerminateProcess:	NtTerminateProcess
// Thread32First		-
// Thread32Next			-
// Toolhelp32ReadProcessMemory
// VirtualAlloc			-
// VirtualAllocEx		NtAllocateVirtualMemory
// VirtualFree			-
// VirtualFreeEx		NtFreeVirtualMemory
// VirtualProtect		-
// VirtualProtectEx		NtProtectVirtualMemory
// VirtualQuery			-
// VirtualQueryEx		NtQueryVirtualMemory
// WriteProcessMemory:	NtWriteVirtualMemory
//
// TODO: 
//
//		 Implement FindWindow,GetWindowThreadProcessId
//		 Implement CreateToolhelp32Snapshot
//
// Credits:
//		ReactOS, undocumented.ntinternals, DDK, Game-Deception
//
//############################################################################
#include "stdafx.h"
//# include <tchar.h>
//#include <stdio.h>
#include "secureApi.h"


namespace secureApi
{
	BOOL RunOnce = FALSE;
	DWORD Version;

	NTSTATUS (* KiFastSystemCall)();
	DWORD syscallTable[201][6] = {
		/* NT 4,  2000,   XP,     2k3S,   Vista,  7 */
		{ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0060 }, /* NtAcceptConnectPort */
		{ 0x0001, 0x0001, 0x0001, 0x0001, 0x0001, 0x0061 }, /* NtAccessCheck */
		{ 0x0002, 0x0002, 0x0002, 0x0002, 0x0002, 0x0026 }, /* NtAccessCheckAndAuditAlarm */
		{ 0x0003, 0x0008, 0x0008, 0x0008, 0x0008, 0x0008 }, /* NtAddAtom */
		{ 0x0004, 0x0009, 0x000a, 0x000b, 0x000b, 0x0068 }, /* NtAdjustGroupsToken */
		{ 0x0005, 0x000a, 0x000b, 0x000c, 0x000c, 0x003e }, /* NtAdjustPrivilegesToken */
		{ 0x0006, 0x000b, 0x000c, 0x000d, 0x000d, 0x0069 }, /* NtAlertResumeThread */
		{ 0x0007, 0x000c, 0x000d, 0x000e, 0x000e, 0x006a }, /* NtAlertThread */
		{ 0x0008, 0x000d, 0x000e, 0x000f, 0x000f, 0x006b }, /* NtAllocateLocallyUniqueId */
		{ 0x0009, 0x000f, 0x0010, 0x0011, 0x0011, 0x006e }, /* NtAllocateUuids */
		{ 0x000a, 0x0010, 0x0011, 0x0012, 0x0012, 0x0015 }, /* NtAllocateVirtualMemory */
		{ 0x000b, 0x0013, 0x0014, 0x0016, 0x002a, 0x0002 }, /* NtCallbackReturn */
		{ 0x000c, 0x0014, 0x0016, 0x0018, 0x002c, 0x005a }, /* NtCancelIoFile */
		{ 0x000d, 0x0015, 0x0017, 0x0019, 0x002d, 0x005e }, /* NtCancelTimer */
		{ 0x000e, 0x0017, 0x0018, 0x001a, 0x002e, 0x003b }, /* NtClearEvent */
		{ 0x000f, 0x0018, 0x0019, 0x001b, 0x002f, 0x000c }, /* NtClose */
		{ 0x0010, 0x0019, 0x001a, 0x001c, 0x0030, 0x0038 }, /* NtCloseObjectAuditAlarm */
		{ 0x0011, 0x001a, 0x001d, 0x001f, 0x0033, 0x0039 }, /* NtCompleteConnectPort */
		{ 0x0012, 0x001b, 0x001f, 0x0021, 0x0035, 0x008f }, /* NtConnectPort */
		{ 0x0013, 0x001c, 0x0020, 0x0022, 0x0036, 0x0040 }, /* NtContinue */
		{ 0x0014, 0x001d, 0x0022, 0x0024, 0x0038, 0x0091 }, /* NtCreateDirectoryObject */
		{ 0x0015, 0x001e, 0x0023, 0x0025, 0x0039, 0x0045 }, /* NtCreateEvent */
		{ 0x0016, 0x001f, 0x0024, 0x0026, 0x003a, 0x0093 }, /* NtCreateEventPair */
		{ 0x0017, 0x0020, 0x0025, 0x0027, 0x003b, 0x0052 }, /* NtCreateFile */
		{ 0x0018, 0x0021, 0x0026, 0x0028, 0x003c, 0x0094 }, /* NtCreateIoCompletion */
		{ 0x0019, 0x0023, 0x0029, 0x002b, 0x003f, 0x001a }, /* NtCreateKey */
		{ 0x001a, 0x0024, 0x002a, 0x002c, 0x0040, 0x0099 }, /* NtCreateMailslotFile */
		{ 0x001b, 0x0025, 0x002b, 0x002d, 0x0041, 0x009a }, /* NtCreateMutant */
		{ 0x001c, 0x0026, 0x002c, 0x002e, 0x0042, 0x009b }, /* NtCreateNamedPipeFile */
		{ 0x001d, 0x0027, 0x002d, 0x002f, 0x0044, 0x009c }, /* NtCreatePagingFile */
		{ 0x001e, 0x0028, 0x002e, 0x0030, 0x0045, 0x009d }, /* NtCreatePort */
		{ 0x001f, 0x0029, 0x002f, 0x0031, 0x0046, 0x009f }, /* NtCreateProcess */
		{ 0x0020, 0x002a, 0x0031, 0x0033, 0x0048, 0x00a0 }, /* NtCreateProfile */
		{ 0x0021, 0x002b, 0x0032, 0x0034, 0x0049, 0x0054 }, /* NtCreateSection */
		{ 0x0022, 0x002c, 0x0033, 0x0035, 0x004a, 0x00a3 }, /* NtCreateSemaphore */
		{ 0x0023, 0x002d, 0x0034, 0x0036, 0x004b, 0x00a4 }, /* NtCreateSymbolicLinkObject */
		{ 0x0024, 0x002e, 0x0035, 0x0037, 0x004c, 0x004b }, /* NtCreateThread */
		{ 0x0025, 0x002f, 0x0036, 0x0038, 0x004d, 0x00a6 }, /* NtCreateTimer */
		{ 0x0026, 0x0030, 0x0037, 0x0039, 0x004e, 0x00a7 }, /* NtCreateToken */
		{ 0x0027, 0x0032, 0x003b, 0x003d, 0x0075, 0x0031 }, /* NtDelayExecution */
		{ 0x0028, 0x0033, 0x003c, 0x003e, 0x0076, 0x00af }, /* NtDeleteAtom */
		{ 0x0029, 0x0034, 0x003e, 0x0041, 0x0079, 0x00b2 }, /* NtDeleteFile */
		{ 0x002a, 0x0035, 0x003f, 0x0042, 0x007a, 0x00b3 }, /* NtDeleteKey */
		{ 0x002b, 0x0036, 0x0040, 0x0043, 0x007c, 0x00b4 }, /* NtDeleteObjectAuditAlarm */
		{ 0x002c, 0x0037, 0x0041, 0x0044, 0x007d, 0x00b6 }, /* NtDeleteValueKey */
		{ 0x002d, 0x0038, 0x0042, 0x0045, 0x007e, 0x0004 }, /* NtDeviceIoControlFile */
		{ 0x002e, 0x0039, 0x0043, 0x0046, 0x007f, 0x00b8 }, /* NtDisplayString */
		{ 0x002f, 0x003a, 0x0044, 0x0047, 0x0080, 0x0039 }, /* NtDuplicateObject */
		{ 0x0030, 0x003b, 0x0045, 0x0048, 0x0081, 0x003f }, /* NtDuplicateToken */
		{ 0x0031, 0x003c, 0x0047, 0x004b, 0x0084, 0x002f }, /* NtEnumerateKey */
		{ 0x0032, 0x003d, 0x0049, 0x004d, 0x0086, 0x0010 }, /* NtEnumerateValueKey */
		{ 0x0033, 0x003e, 0x004a, 0x004e, 0x0087, 0x00bf }, /* NtExtendSection */
		{ 0x0034, 0x0040, 0x004c, 0x0050, 0x0089, 0x0011 }, /* NtFindAtom */
		{ 0x0035, 0x0041, 0x004d, 0x0051, 0x008a, 0x0048 }, /* NtFlushBuffersFile */
		{ 0x0036, 0x0042, 0x004e, 0x0052, 0x008b, 0x00c2 }, /* NtFlushInstructionCache */
		{ 0x0037, 0x0043, 0x004f, 0x0053, 0x008c, 0x00c3 }, /* NtFlushKey */
		{ 0x0038, 0x0044, 0x0050, 0x0054, 0x008e, 0x00c5 }, /* NtFlushVirtualMemory */
		{ 0x0039, 0x0045, 0x0051, 0x0055, 0x008f, 0x00c6 }, /* NtFlushWriteBuffer */
		{ 0x003a, 0x0047, 0x0053, 0x0057, 0x0091, 0x001b }, /* NtFreeVirtualMemory */
		{ 0x003b, 0x0048, 0x0054, 0x0058, 0x0094, 0x0036 }, /* NtFsControlFile */
		{ 0x003c, 0x0049, 0x0055, 0x0059, 0x0095, 0x00ca }, /* NtGetContextThread */
		{ 0x003d, 0x004b, 0x0057, 0x005b, 0x0098, 0x00d2 }, /* NtGetPlugPlayEvent */
		{ 0x003f, 0x004f, 0x005a, 0x005e, 0x009b, 0x001c }, /* NtImpersonateClientOfPort */
		{ 0x0040, 0x0050, 0x005b, 0x005f, 0x009c, 0x00d5 }, /* NtImpersonateThread */
		{ 0x0041, 0x0051, 0x005c, 0x0060, 0x009e, 0x00d7 }, /* NtInitializeRegistry */
		{ 0x0042, 0x0054, 0x0060, 0x0064, 0x00a2, 0x00db }, /* NtListenPort */
		{ 0x0043, 0x0055, 0x0061, 0x0065, 0x00a3, 0x00dc }, /* NtLoadDriver */
		{ 0x0044, 0x0056, 0x0062, 0x0066, 0x00a4, 0x00dd }, /* NtLoadKey */
		{ 0x0045, 0x0057, 0x0063, 0x0067, 0x00a5, 0x00de }, /* NtLoadKey2 */
		{ 0x0046, 0x0058, 0x0064, 0x0069, 0x00a7, 0x00e0 }, /* NtLockFile */
		{ 0x0047, 0x0059, 0x0067, 0x006c, 0x00aa, 0x00e3 }, /* NtLockVirtualMemory */
		{ 0x0048, 0x005a, 0x0069, 0x006e, 0x00ac, 0x00e5 }, /* NtMakeTemporaryObject */
		{ 0x0049, 0x005d, 0x006c, 0x0071, 0x00af, 0x0025 }, /* NtMapViewOfSection */
		{ 0x004a, 0x005e, 0x006e, 0x0074, 0x00b2, 0x00ea }, /* NtNotifyChangeDirectoryFile */
		{ 0x004b, 0x005f, 0x006f, 0x0075, 0x00b3, 0x00eb }, /* NtNotifyChangeKey */
		{ 0x004c, 0x0061, 0x0071, 0x0077, 0x00b5, 0x0055 }, /* NtOpenDirectoryObject */
		{ 0x004d, 0x0062, 0x0072, 0x0078, 0x00b6, 0x003D }, /* NtOpenEvent */
		{ 0x004e, 0x0063, 0x0073, 0x0079, 0x00b7, 0x00ef }, /* NtOpenEventPair */
		{ 0x004f, 0x0064, 0x0074, 0x007a, 0x00b8, 0x0030 }, /* NtOpenFile */
		{ 0x0050, 0x0065, 0x0075, 0x007b, 0x00b9, 0x00f0 }, /* NtOpenIoCompletion */
		{ 0x0051, 0x0067, 0x0077, 0x007d, 0x00bb, 0x000f }, /* NtOpenKey */
		{ 0x0052, 0x0068, 0x0078, 0x007e, 0x00bc, 0x00f6 }, /* NtOpenMutant */
		{ 0x0053, 0x0069, 0x0079, 0x007f, 0x00be, 0x00f7 }, /* NtOpenObjectAuditAlarm */
		{ 0x0054, 0x006a, 0x007a, 0x0080, 0x00bf, 0x0023 }, /* NtOpenProcess */
		{ 0x0055, 0x006b, 0x007b, 0x0081, 0x00c0, 0x00f9 }, /* NtOpenProcessToken */
		{ 0x0056, 0x006c, 0x007d, 0x0083, 0x00c2, 0x0034 }, /* NtOpenSection */
		{ 0x0057, 0x006d, 0x007e, 0x0084, 0x00c3, 0x00fb }, /* NtOpenSemaphore */
		{ 0x0058, 0x006e, 0x007f, 0x0085, 0x00c5, 0x00fd }, /* NtOpenSymbolicLinkObject */
		{ 0x0059, 0x006f, 0x0080, 0x0086, 0x00c6, 0x00fe }, /* NtOpenThread */
		{ 0x005a, 0x0070, 0x0081, 0x0087, 0x00c7, 0x00c7 }, /* NtOpenThreadToken */
		{ 0x005b, 0x0071, 0x0083, 0x0089, 0x00c9, 0x00ff }, /* NtOpenTimer */
		{ 0x005c, 0x0072, 0x0084, 0x008a, 0x00ca, 0x0102 }, /* NtPlugPlayControl */
		{ 0x005d, 0x0074, 0x0086, 0x008c, 0x00cc, 0x0107 }, /* NtPrivilegeCheck */
		{ 0x005f, 0x0076, 0x0087, 0x008d, 0x00cd, 0x0108 }, /* NtPrivilegeObjectAuditAlarm */
		{ 0x005e, 0x0075, 0x0088, 0x008e, 0x00ce, 0x0109 }, /* NtPrivilegedServiceAuditAlarm */
		{ 0x0060, 0x0077, 0x0089, 0x008f, 0x00cf, 0x004D }, /* NtProtectVirtualMemory */
		{ 0x0061, 0x0078, 0x008a, 0x0090, 0x00d0, 0x010c }, /* NtPulseEvent */
		{ 0x0063, 0x007a, 0x008b, 0x0091, 0x00d1, 0x003a }, /* NtQueryAttributesFile */
		{ 0x0064, 0x007b, 0x008f, 0x0095, 0x00d5, 0x0012 }, /* NtQueryDefaultLocale */
		{ 0x0065, 0x007d, 0x0091, 0x0097, 0x00d7, 0x0032 }, /* NtQueryDirectoryFile */
		{ 0x0066, 0x007e, 0x0092, 0x0098, 0x00d8, 0x0110 }, /* NtQueryDirectoryObject */
		{ 0x0067, 0x007f, 0x0093, 0x009a, 0x00da, 0x0112 }, /* NtQueryEaFile */
		{ 0x0068, 0x0080, 0x0094, 0x009b, 0x00db, 0x0053 }, /* NtQueryEvent */
		{ 0x0069, 0x0081, 0x0095, 0x009c, 0x00dc, 0x0114 }, /* NtQueryFullAttributesFile */
		{ 0x0062, 0x0079, 0x0096, 0x009d, 0x00dd, 0x00e5 }, /* NtQueryInformationAtom */
		{ 0x006a, 0x0082, 0x0097, 0x009e, 0x00de, 0x000e }, /* NtQueryInformationFile */
		{ 0x006c, 0x0085, 0x0099, 0x00a0, 0x00e0, 0x0117 }, /* NtQueryInformationPort */
		{ 0x006d, 0x0086, 0x009a, 0x00a1, 0x00e1, 0x0016 }, /* NtQueryInformationProcess */
		{ 0x006e, 0x0087, 0x009b, 0x00a2, 0x00e2, 0x0022 }, /* NtQueryInformationThread */
		{ 0x006f, 0x0088, 0x009c, 0x00a3, 0x00e3, 0x001e }, /* NtQueryInformationToken */
		{ 0x0070, 0x008a, 0x009e, 0x00a5, 0x00e5, 0x011d }, /* NtQueryIntervalProfile */
		{ 0x006b, 0x0084, 0x009f, 0x00a6, 0x00e6, 0x011e }, /* NtQueryIoCompletion */
		{ 0x0071, 0x008b, 0x00a0, 0x00a7, 0x00e7, 0x0013 }, /* NtQueryKey */
		{ 0x0072, 0x008c, 0x00a1, 0x00a8, 0x00e8, 0x0120 }, /* NtQueryMultipleValueKey */
		{ 0x0073, 0x008d, 0x00a2, 0x00a9, 0x00e9, 0x0121 }, /* NtQueryMutant */
		{ 0x0074, 0x008e, 0x00a3, 0x00aa, 0x00ea, 0x000d }, /* NtQueryObject */
		{ 0x0076, 0x0090, 0x00a5, 0x00ad, 0x00ed, 0x002e }, /* NtQueryPerformanceCounter */
		{ 0x0077, 0x0092, 0x00a7, 0x00af, 0x00ef, 0x004e }, /* NtQuerySection */
		{ 0x0078, 0x0093, 0x00a8, 0x00b0, 0x00f0, 0x0127 }, /* NtQuerySecurityObject */
		{ 0x0079, 0x0094, 0x00a9, 0x00b1, 0x00f1, 0x0128 }, /* NtQuerySemaphore */
		{ 0x007a, 0x0095, 0x00aa, 0x00b2, 0x00f2, 0x0129 }, /* NtQuerySymbolicLinkObject */
		{ 0x007b, 0x0096, 0x00ab, 0x00b3, 0x00f3, 0x012A }, /* NtQuerySystemEnvironmentValue */
		{ 0x007c, 0x0097, 0x00ad, 0x00b5, 0x00f5, 0x0033 }, /* NtQuerySystemInformation */
		{ 0x007d, 0x0098, 0x00ae, 0x00b6, 0x00f6, 0x0057 }, /* NtQuerySystemTime */
		{ 0x007e, 0x0099, 0x00af, 0x00b7, 0x00f7, 0x0035 }, /* NtQueryTimer */
		{ 0x007f, 0x009a, 0x00b0, 0x00b8, 0x00f8, 0x012d }, /* NtQueryTimerResolution */
		{ 0x0080, 0x009b, 0x00b1, 0x00b9, 0x00f9, 0x0014 }, /* NtQueryValueKey */
		{ 0x0081, 0x009c, 0x00b2, 0x00ba, 0x00fa, 0x0020 }, /* NtQueryVirtualMemory */
		{ 0x0082, 0x009d, 0x00b3, 0x00bb, 0x00fb, 0x0046 }, /* NtQueryVolumeInformationFile */
		{ 0x0083, 0x009e, 0x00b4, 0x00bc, 0x00fc, 0x0042 }, /* NtQueueApcThread */
		{ 0x0084, 0x009f, 0x00b5, 0x00bd, 0x00fd, 0x012f }, /* NtRaiseException */
		{ 0x0085, 0x00a0, 0x00b6, 0x00be, 0x00fe, 0x0130 }, /* NtRaiseHardError */
		{ 0x0086, 0x00a1, 0x00b7, 0x00bf, 0x00ff, 0x0003 }, /* NtReadFile */
		{ 0x0087, 0x00a2, 0x00b8, 0x00c0, 0x0100, 0x002b }, /* NtReadFileScatter */
		{ 0x0088, 0x00a3, 0x00b9, 0x00c1, 0x0101, 0x0051 }, /* NtReadRequestData */
		{ 0x0089, 0x00a4, 0x00ba, 0x00c2, 0x0102, 0x003c }, /* NtReadVirtualMemory */
		{ 0x008a, 0x00a5, 0x00bb, 0x00c3, 0x0103, 0x0136 }, /* NtRegisterThreadTerminatePort */
		{ 0x008b, 0x00a6, 0x00bc, 0x00c4, 0x0104, 0x001d }, /* NtReleaseMutant */
		{ 0x008c, 0x00a7, 0x00bd, 0x00c5, 0x0105, 0x0007 }, /* NtReleaseSemaphore */
		{ 0x008d, 0x00a8, 0x00be, 0x00c6, 0x0106, 0x0006 }, /* NtRemoveIoCompletion */
		{ 0x008e, 0x00a9, 0x00c1, 0x00c9, 0x0109, 0x013d }, /* NtReplaceKey */
		{ 0x008f, 0x00aa, 0x00c2, 0x00ca, 0x010a, 0x0009 }, /* NtReplyPort */
		{ 0x0090, 0x00ab, 0x00c3, 0x00cb, 0x010b, 0x0008 }, /* NtReplyWaitReceivePort */
		{ 0x0091, 0x00ad, 0x00c5, 0x00cd, 0x010d, 0x013f }, /* NtReplyWaitReplyPort */
		{ 0x0092, 0x00af, 0x00c7, 0x00cf, 0x010f, 0x0140 }, /* NtRequestPort */
		{ 0x0093, 0x00b0, 0x00c8, 0x00d0, 0x0110, 0x001f }, /* NtRequestWaitReplyPort */
		{ 0x0094, 0x00b2, 0x00ca, 0x00d2, 0x0112, 0x0141 }, /* NtResetEvent */
		{ 0x0095, 0x00b4, 0x00cc, 0x00d4, 0x0114, 0x0143 }, /* NtRestoreKey */
		{ 0x0096, 0x00b5, 0x00ce, 0x00d6, 0x0116, 0x004f }, /* NtResumeThread */
		{ 0x0097, 0x00b6, 0x00cf, 0x00d7, 0x0117, 0x0149 }, /* NtSaveKey */
		{ 0x0099, 0x00ba, 0x00d5, 0x00dd, 0x0122, 0x0150 }, /* NtSetContextThread */
		{ 0x009a, 0x00bb, 0x00d7, 0x00df, 0x0124, 0x0152 }, /* NtSetDefaultHardErrorPort */
		{ 0x009b, 0x00bc, 0x00d8, 0x00e0, 0x0125, 0x0153 }, /* NtSetDefaultLocale */
		{ 0x009c, 0x00be, 0x00da, 0x00e3, 0x0128, 0x0156 }, /* NtSetEaFile */
		{ 0x009d, 0x00bf, 0x00db, 0x00e4, 0x0129, 0x000b }, /* NtSetEvent */
		{ 0x009e, 0x00c0, 0x00dd, 0x00e6, 0x012b, 0x0157 }, /* NtSetHighEventPair */
		{ 0x009f, 0x00c1, 0x00de, 0x00e7, 0x012c, 0x0158 }, /* NtSetHighWaitLowEventPair */
		{ 0x00a1, 0x00c2, 0x00e0, 0x00e9, 0x012e, 0x0024 }, /* NtSetInformationFile */
		{ 0x00a2, 0x00c4, 0x00e2, 0x00eb, 0x0130, 0x015c }, /* NtSetInformationKey */
		{ 0x00a3, 0x00c5, 0x00e3, 0x00ec, 0x0131, 0x0059 }, /* NtSetInformationObject */
		{ 0x00a4, 0x00c6, 0x00e4, 0x00ed, 0x0132, 0x0019 }, /* NtSetInformationProcess */
		{ 0x00a5, 0x00c7, 0x00e5, 0x00ee, 0x0133, 0x000A }, /* NtSetInformationThread */
		{ 0x00a6, 0x00c8, 0x00e6, 0x00ef, 0x0134, 0x015e }, /* NtSetInformationToken */
		{ 0x00a7, 0x00c9, 0x00e7, 0x00f0, 0x0135, 0x0162 }, /* NtSetIntervalProfile */
		{ 0x0098, 0x00b9, 0x00e8, 0x00f1, 0x0136, 0x0163 }, /* NtSetIoCompletion */
		{ 0x00a8, 0x00ca, 0x00e9, 0x00f2, 0x0137, 0x0165 }, /* NtSetLdtEntries */
		{ 0x00a9, 0x00cb, 0x00ea, 0x00f3, 0x0138, 0x0166 }, /* NtSetLowEventPair */
		{ 0x00aa, 0x00cc, 0x00eb, 0x00f4, 0x0139, 0x0167 }, /* NtSetLowWaitHighEventPair */
		{ 0x00ac, 0x00ce, 0x00ed, 0x00f6, 0x013b, 0x0169 }, /* NtSetSecurityObject */
		{ 0x00ad, 0x00cf, 0x00ee, 0x00f7, 0x013c, 0x016a }, /* NtSetSystemEnvironmentValue */
		{ 0x00ae, 0x00d0, 0x00f0, 0x00f9, 0x013e, 0x016c }, /* NtSetSystemInformation */
		{ 0x00af, 0x00d1, 0x00f1, 0x00fa, 0x013f, 0x016d }, /* NtSetSystemPowerState */
		{ 0x00b0, 0x00d2, 0x00f2, 0x00fb, 0x0140, 0x016e }, /* NtSetSystemTime */
		{ 0x00b1, 0x00d4, 0x00f4, 0x00fd, 0x0142, 0x005f }, /* NtSetTimer */
		{ 0x00b2, 0x00d5, 0x00f5, 0x00fe, 0x0143, 0x0171 }, /* NtSetTimerResolution */
		{ 0x00b3, 0x00d7, 0x00f7, 0x0100, 0x0145, 0x005d }, /* NtSetValueKey */
		{ 0x00b4, 0x00d8, 0x00f8, 0x0101, 0x0146, 0x0173 }, /* NtSetVolumeInformationFile */
		{ 0x00b5, 0x00d9, 0x00f9, 0x0102, 0x0147, 0x0174 }, /* NtShutdownSystem */
		{ 0x00b6, 0x00da, 0x00fa, 0x0103, 0x0148, 0x0176 }, /* NtSignalAndWaitForSingleObject */
		{ 0x00b7, 0x00db, 0x00fb, 0x0104, 0x0149, 0x0178 }, /* NtStartProfile */
		{ 0x00b8, 0x00dc, 0x00fc, 0x0105, 0x014a, 0x0179 }, /* NtStopProfile */
		{ 0x00b9, 0x00dd, 0x00fe, 0x0107, 0x014c, 0x017b }, /* NtSuspendThread */
		{ 0x00ba, 0x00de, 0x00ff, 0x0108, 0x014d, 0x017c }, /* NtSystemDebugControl */
		{ 0x00bb, 0x00e0, 0x0101, 0x010a, 0x014f, 0x0029 }, /* NtTerminateProcess */
		{ 0x00bc, 0x00e1, 0x0102, 0x010b, 0x0150, 0x0050 }, /* NtTerminateThread */
		{ 0x00bd, 0x00e2, 0x0103, 0x010c, 0x0151, 0x017e }, /* NtTestAlert */
		{ 0x00be, 0x00e3, 0x0106, 0x010f, 0x0157, 0x0184 }, /* NtUnloadDriver */
		{ 0x00bf, 0x00e4, 0x0107, 0x0110, 0x0158, 0x0185 }, /* NtUnloadKey */
		{ 0x00c0, 0x00e5, 0x0109, 0x0113, 0x015b, 0x0188 }, /* NtUnlockFile */
		{ 0x00c1, 0x00e6, 0x010a, 0x0114, 0x015c, 0x0189 }, /* NtUnlockVirtualMemory */
		{ 0x00c2, 0x00e7, 0x010b, 0x0115, 0x015d, 0x0027 }, /* NtUnmapViewOfSection */
		{ 0x00c3, 0x00e8, 0x010c, 0x0116, 0x015e, 0x018a }, /* NtVdmControl */
		{ 0x00c4, 0x00e9, 0x010e, 0x0118, 0x0160, 0x0058 }, /* NtWaitForMultipleObjects */
		{ 0x00c5, 0x00ea, 0x010f, 0x0119, 0x0161, 0x0001 }, /* NtWaitForSingleObject */
		{ 0x00c6, 0x00eb, 0x0110, 0x011a, 0x0162, 0x018e }, /* NtWaitHighEventPair */
		{ 0x00c7, 0x00ec, 0x0111, 0x011b, 0x0163, 0x018f }, /* NtWaitLowEventPair */
		{ 0x00c8, 0x00ed, 0x0112, 0x011c, 0x0164, 0x0005 }, /* NtWriteFile */
		{ 0x00c9, 0x00ee, 0x0113, 0x011d, 0x0165, 0x0018 }, /* NtWriteFileGather */
		{ 0x00ca, 0x00ef, 0x0114, 0x011e, 0x0166, 0x0054 }, /* NtWriteRequestData */
		{ 0x00cb, 0x00f0, 0x0115, 0x011f, 0x0167, 0x0037 }, /* NtWriteVirtualMemory */
		{ 0x00d3, 0x00f7, 0x0116, 0x0120, 0x0168, 0x0043 }  /* NtYieldExecution */
	};


//#define NtOpenProcess ((_OpenProcess)secureApi::GetProcAddress( GetModuleHandle( TEXT("ntdll.dll") ),"NtOpenProcess" ))
//#define NtTerminateProcess ((_TerminateProcess)secureApi::GetProcAddress( GetModuleHandle( TEXT("ntdll.dll") ),"NtTerminateProcess" ))
//#define NtClose ((_CloseHandle)secureApi::GetProcAddress( GetModuleHandle( TEXT("ntdll.dll") ),"NtClose" ))
//#define NtReadVirtualMemory ((_ReadProcessMemory)secureApi:: GetProcAddress( GetModuleHandle( TEXT("ntdll.dll") ),"NtReadVirtualMemory" ))
//#define NtWriteVirtualMemory ((_WriteProcessMemory)secureApi:: GetProcAddress( GetModuleHandle( TEXT("ntdll.dll") ),"NtWriteVirtualMemory" ))
//#define RtlInitAnsiString ((_RtlInitAnsiString)secureApi:: GetProcAddress( GetModuleHandle( TEXT("ntdll.dll") ),"RtlInitAnsiString" ))
//#define LdrGetProcedureAddress ((_LdrGetProcedureAddress)secureApi::GetProcAddress( GetModuleHandle( TEXT("ntdll.dll") ),"LdrGetProcedureAddress" ))
//#define NtOpenThread ((_NtOpenThread)secureApi:: GetProcAddress( GetModuleHandle( TEXT("ntdll.dll") ),"NtOpenThread" ))
// #define NtAllocateVirtualMemory ((_NtAllocateVirtualMemory)secureApi:: GetProcAddress( GetModuleHandle( TEXT("ntdll.dll") ),"NtAllocateVirtualMemory" ))
// #define NtFreeVirtualMemory ((_NtFreeVirtualMemory)secureApi:: GetProcAddress( GetModuleHandle( TEXT("ntdll.dll") ),"NtFreeVirtualMemory" ))
// #define NtProtectVirtualMemory ((_NtProtectVirtualMemory)secureApi:: GetProcAddress( GetModuleHandle( TEXT("ntdll.dll") ),"NtProtectVirtualMemory" ))
// #define NtMapViewOfSection ((_NtMapViewOfSection)secureApi:: GetProcAddress( GetModuleHandle( TEXT("ntdll.dll") ),"NtMapViewOfSection" ))
#define RtlAnsiStringToUnicodeString ((_RtlAnsiStringToUnicodeString)secureApi::GetProcAddress(secureApi::GetModuleHandleW(L"ntdll.dll"),"RtlAnsiStringToUnicodeString" ))
#define LdrLoadDll ((_LdrLoadDll)secureApi:: GetProcAddress(secureApi::GetModuleHandleW(L"ntdll.dll"),"LdrLoadDll" ))
#define RtlFreeUnicodeString ((_RtlFreeUnicodeString)secureApi:: GetProcAddress(secureApi::GetModuleHandleW(L"ntdll.dll"),"RtlFreeUnicodeString" ))
#define RtlAllocateHeap ((_RtlAllocateHeap)secureApi::GetProcAddress(secureApi::GetModuleHandleW(L"ntdll.dll"),"RtlAllocateHeap" ))
#define RtlReAllocateHeap ((_RtlReAllocateHeap)secureApi::GetProcAddress(secureApi::GetModuleHandleW(L"ntdll.dll"),"RtlReAllocateHeap" ))
#define RtlFreeHeap ((_RtlFreeHeap)secureApi::GetProcAddress(secureApi::GetModuleHandleW(L"ntdll.dll"),"RtlFreeHeap" ))
// #define NtQueryVirtualMemory ((_NtQueryVirtualMemory)secureApi:: GetProcAddress( GetModuleHandle( TEXT("ntdll.dll") ),"NtQueryVirtualMemory" ))
// #define NtUnmapViewOfSection ((_NtUnmapViewOfSection)secureApi:: GetProcAddress( GetModuleHandle( TEXT("ntdll.dll") ),"NtUnmapViewOfSection" ))


// BOOL WINAPI secureApi::CloseHandle(HANDLE handle)
// {
//     NTSTATUS status;
// 
//     status = NtClose(handle);
//     return !status;
// }

BOOL WINAPI CloseHandle( HANDLE Object )
{
	return( _NtClose( Object ) );
}

HANDLE WINAPI GetCurrentProcess(void)
{
    return (HANDLE)0xffffffff;
}

// HANDLE WINAPI GetCurrentProcess()
// {
// 	return (HANDLE)~(DWORD_PTR)0;
// }

HANDLE WINAPI GetCurrentThread(void)
{
    return (HANDLE)0xfffffffe;
}

// HANDLE WINAPI GetCurrentThread()
// {
// 	return (HANDLE)~(DWORD_PTR)1;
// }

DWORD WINAPI GetCurrentThreadId(void)
{
    return (DWORD)NtCurrentTeb()->Cid.UniqueThread;
}

HANDLE WINAPI GetProcessHeap(void)
{
    return NtCurrentTeb()->Peb->ProcessHeap;
}

LONG WINAPI RtlCompareUnicodeString(IN PUNICODE_STRING s1,IN PUNICODE_STRING s2)
{
   unsigned int len;
   LONG ret = 0;
   LPCWSTR p1, p2;

   len = min(s1->Length, s2->Length) / sizeof(WCHAR);
   p1 = (LPCWSTR)s1->Buffer;
   p2 = (LPCWSTR)s2->Buffer;

   while (!ret && len--) ret = *p1++ - *p2++;
   if (!ret) ret = s1->Length - s2->Length;

   return ret;
}

// LONG WINAPI CompareUnicodeString(IN PUNICODE_STRING s1, IN LPCSTR s2)
// {
// 	unsigned int len;
// 	LONG ret = 0;
// 	LPCWSTR p1,p2;
// 
// 	len = min(s1->Length, strlen(s2)) / sizeof(WCHAR);
// 	p1 = (LPCWSTR)s1->Buffer;
// 
//     wchar_t pwsz[sizeof(s2)*2];
//     MultiByteToWideChar(CP_ACP, 0, s2, strlen(s2), pwsz, sizeof(pwsz));
//     p2 = pwsz;
// 
//     while (!ret && len--) ret = *p1++ - *p2++;
//     return ret;
// }
// 
// 
// HMODULE WINAPI GetModuleHandle(LPCSTR lpModuleName)
// {
// 	PLIST_ENTRY fModule,fMark;
// 	PLDR_MODULE pMod;
// 
// 	fMark = &NtCurrentTeb()->Peb->LoaderData->InLoadOrderModuleList;
// 
// 	for(fModule = fMark->Flink; fModule != fMark; fModule = fModule->Flink)
// 	{
// 		pMod = (PLDR_MODULE)fModule;
// 		if(CompareUnicodeString(&pMod->BaseDllName,lpModuleName) == 0)
// 		{
// 			return (HMODULE)pMod->BaseAddress;
// 		}
// 	}
// 
// 	return NULL;
// }

HMODULE WINAPI GetModuleHandleW( LPCWSTR ModuleName )
{
	PLIST_ENTRY pebModuleHeader, ModuleLoop;
	PLDR_MODULE lclModule;
	PPEB_LDR_DATA pebModuleLdr;
	DWORD BadModuleCount = 0;

#if _M_IX86
	pebModuleLdr = ( PPEB_LDR_DATA ) *( ( DWORD_PTR * ) __readfsdword( 0x30 ) + 12 / sizeof( DWORD_PTR ) );
#elif _M_X64
	pebModuleLdr = ( PPEB_LDR_DATA ) *( ( DWORD_PTR * ) __readgsqword( 0x60 ) + 24 / sizeof( DWORD_PTR ) );
#endif

	pebModuleHeader = ( PLIST_ENTRY ) &pebModuleLdr->InLoadOrderModuleList;

	lclModule = ( PLDR_MODULE ) pebModuleHeader->Flink;
	ModuleLoop = pebModuleHeader->Flink;
	do
	{
		if( !wcscmp( ModuleName, lclModule->BaseDllName.Buffer ) )
		{
			return( ( HMODULE ) lclModule->BaseAddress );
		}
		lclModule = ( PLDR_MODULE ) ModuleLoop->Flink;
		ModuleLoop = ModuleLoop->Flink;
	} while( pebModuleHeader != ModuleLoop);

	return( 0 );
}


LPCWSTR WINAPI GetModuleFileNameW(HMODULE handle)
{
	PLIST_ENTRY fModule,fMark;
	PLDR_MODULE pMod;

	fMark = &NtCurrentTeb()->Peb->LoaderData->InLoadOrderModuleList;

	for(fModule = fMark->Flink; fModule != fMark; fModule = fModule->Flink)
	{
		pMod = (PLDR_MODULE)fModule;
		if(pMod->BaseAddress == handle)
		{
			return pMod->BaseDllName.Buffer;
		}
	}

	return NULL;
}


DWORD WINAPI GetVersion(void)
{
    DWORD result = MAKELONG( MAKEWORD( NtCurrentTeb()->Peb->OSMajorVersion,
				   NtCurrentTeb()->Peb->OSMinorVersion ),(NtCurrentTeb()->Peb->OSPlatformId ^ 2) << 14 );

    if (NtCurrentTeb()->Peb->OSPlatformId == VER_PLATFORM_WIN32_NT)
        result |= LOWORD(NtCurrentTeb()->Peb->OSBuildNumber) << 16;

    return result;
}

DWORD WINAPI GetModuleSize(HMODULE hModule)
{
	if(hModule == NULL) return 0;
	PBYTE pbImageBase = (PBYTE)hModule;
	PIMAGE_DOS_HEADER DosHeader = (PIMAGE_DOS_HEADER)pbImageBase;
	PIMAGE_NT_HEADERS NTHeaders = (PIMAGE_NT_HEADERS)(pbImageBase + DosHeader->e_lfanew);

	return NTHeaders->OptionalHeader.SizeOfImage;
}

FARPROC WINAPI GetProcAddress(HMODULE hModule, LPCSTR function)
{
	PBYTE pbImageBase = (PBYTE)hModule;
	INT idx=-1;
	DWORD i, *nameRef;
	WORD *ordinal;

	PIMAGE_DOS_HEADER DosHeader = (PIMAGE_DOS_HEADER)pbImageBase;
	PIMAGE_NT_HEADERS NTHeaders = (PIMAGE_NT_HEADERS)(pbImageBase + DosHeader->e_lfanew);
	IMAGE_DATA_DIRECTORY& expDir = NTHeaders->OptionalHeader.DataDirectory[IMAGE_DIRECTORY_ENTRY_EXPORT];
	PIMAGE_EXPORT_DIRECTORY ExpDir = (PIMAGE_EXPORT_DIRECTORY)(pbImageBase + expDir.VirtualAddress);

	nameRef = (DWORD *)(pbImageBase + ExpDir->AddressOfNames);
	ordinal = (WORD *)(pbImageBase + ExpDir->AddressOfNameOrdinals);

	for (i=0; i<ExpDir->NumberOfNames-1; i++, nameRef++, ordinal++)
	{
		if (_stricmp(function, (const char *)(pbImageBase + *nameRef)) == 0)
		{
			idx = *ordinal;
			break;
		}
	}

	if (idx == -1) return NULL;
	if ((DWORD)idx > ExpDir->NumberOfFunctions) return NULL;

	return (FARPROC)(pbImageBase + *(DWORD *)(pbImageBase + ExpDir->AddressOfFunctions + (idx*4)));
}

LPVOID WINAPI HeapAlloc(HANDLE heap, DWORD flags, SIZE_T size)
{
    return RtlAllocateHeap( heap, flags, size );
}

LPVOID WINAPI HeapReAlloc(HANDLE heap, DWORD flags, LPVOID ptr, SIZE_T size)
{
    return RtlReAllocateHeap( heap, flags, ptr, size );
}

BOOL WINAPI HeapFree(HANDLE heap, DWORD flags, LPVOID ptr)
{
    return RtlFreeHeap( heap, flags, ptr );
}

BOOL WINAPI IsBadReadPtr(CONST VOID* lp,UINT ucb)
{
	MEMORY_BASIC_INFORMATION MemoryInformation;

	if ( ucb == 0 ) return TRUE;
	secureApi::VirtualQuery (lp,&MemoryInformation,sizeof (MEMORY_BASIC_INFORMATION));

	if ( MemoryInformation.State != MEM_COMMIT ) return TRUE;
	if ( MemoryInformation.RegionSize < ucb ) return TRUE;
	if ( MemoryInformation.Protect == PAGE_EXECUTE ) return TRUE;
	if ( MemoryInformation.Protect == PAGE_NOACCESS )return TRUE;

	return FALSE;
}

BOOL WINAPI IsBadWritePtr(LPVOID lp,UINT ucb)
{
	MEMORY_BASIC_INFORMATION MemoryInformation;

	if ( ucb == 0 )return TRUE;
	VirtualQuery (lp,&MemoryInformation,sizeof (MEMORY_BASIC_INFORMATION));

	if ( MemoryInformation.State != MEM_COMMIT ) return TRUE;
	if ( MemoryInformation.RegionSize < ucb ) return TRUE;
	if ( MemoryInformation.Protect == PAGE_READONLY) return TRUE;
	if ((MemoryInformation.Protect == PAGE_EXECUTE)
	|| (MemoryInformation.Protect == PAGE_EXECUTE_READ))return TRUE;
	if ( MemoryInformation.Protect == PAGE_NOACCESS )return TRUE;

	return FALSE;
}


HMODULE secureApi::LoadLibrary(LPCSTR lpModuleName)
{
	ANSI_STRING asModuleName;
	UNICODE_STRING usModuleName;
	HANDLE hModule;

	asModuleName.Buffer=(PCHAR)lpModuleName;
	asModuleName.Length=strlen(lpModuleName);
	asModuleName.MaximumLength=asModuleName.Length;

	if (!NT_SUCCESS(RtlAnsiStringToUnicodeString(&usModuleName,&asModuleName,TRUE)))
	return NULL;

	if (!NT_SUCCESS(LdrLoadDll(NULL,0,&usModuleName,&hModule)))
	{
		RtlFreeUnicodeString(&usModuleName);
		return NULL;
	}

	RtlFreeUnicodeString(&usModuleName);

	return (HMODULE)hModule;
}

LPVOID WINAPI MapViewOfFile( HANDLE mapping, DWORD access, DWORD offset_high, DWORD offset_low, SIZE_T count )
{
    return MapViewOfFileEx( mapping, access, offset_high, offset_low, count, NULL );
}

LPVOID WINAPI MapViewOfFileEx( HANDLE handle, DWORD access,DWORD offset_high, DWORD offset_low, SIZE_T count, LPVOID addr )
{
    NTSTATUS status;
    LARGE_INTEGER offset;
    ULONG protect;

    offset.u.LowPart  = offset_low;
    offset.u.HighPart = offset_high;

    if (access & FILE_MAP_WRITE) protect = PAGE_READWRITE;
    else if (access & FILE_MAP_READ) protect = PAGE_READONLY;
    else if (access & FILE_MAP_COPY) protect = PAGE_WRITECOPY;
    else protect = PAGE_NOACCESS;

    if ((status = _NtMapViewOfSection( handle, GetCurrentProcess(), &addr, 0, 0, &offset,&count, ViewShare, 0, protect )))
    {
        addr = NULL;
    }
    return addr;
}

BOOL WINAPI module_nextW( HANDLE hSnapShot, LPMODULEENTRY32W lpme, BOOL first )
{
    struct snapshot*    snap;
    BOOL                ret = FALSE;

    if (lpme->dwSize < sizeof (MODULEENTRY32W))
    {
        return FALSE;
    }
    if ((snap = (struct snapshot*)MapViewOfFile( hSnapShot, FILE_MAP_ALL_ACCESS, 0, 0, 0 )))
    {
        if (first) snap->module_pos = 0;
        if (snap->module_pos < snap->module_count)
        {
            LPMODULEENTRY32W pe = (MODULEENTRY32W*)&snap->data[snap->module_offset];
            *lpme = pe[snap->module_pos++];
            ret = TRUE;
        }
        UnmapViewOfFile( snap );
    }

    return ret;
}

BOOL WINAPI Module32FirstW(HANDLE hSnapshot, LPMODULEENTRY32W lpme)
{
    return module_nextW( hSnapshot, lpme, TRUE );
}

BOOL WINAPI Module32NextW(HANDLE hSnapshot, LPMODULEENTRY32W lpme)
{
    return module_nextW( hSnapshot, lpme, FALSE );
}

BOOL WINAPI module_nextA( HANDLE handle, LPMODULEENTRY32 lpme, BOOL first )
{
    BOOL ret;
    MODULEENTRY32W mew;

    if (lpme->dwSize < sizeof(MODULEENTRY32))
    {
        return FALSE;
    }

    mew.dwSize = sizeof(mew);
    if ((ret = module_nextW( handle, &mew, first )))
    {
        lpme->th32ModuleID  = mew.th32ModuleID;
        lpme->th32ProcessID = mew.th32ProcessID;
        lpme->GlblcntUsage  = mew.GlblcntUsage;
        lpme->ProccntUsage  = mew.ProccntUsage;
        lpme->modBaseAddr   = mew.modBaseAddr;
        lpme->modBaseSize   = mew.modBaseSize;
        lpme->hModule       = mew.hModule;
        WideCharToMultiByte( CP_ACP, 0, mew.szModule, -1, lpme->szModule, sizeof(lpme->szModule), NULL, NULL );
        WideCharToMultiByte( CP_ACP, 0, mew.szExePath, -1, lpme->szExePath, sizeof(lpme->szExePath), NULL, NULL );
    }
    return ret;
}

BOOL WINAPI Module32First(HANDLE hSnapshot, LPMODULEENTRY32 lpme)
{
    return module_nextA( hSnapshot, lpme, TRUE );
}

BOOL WINAPI Module32Next(HANDLE hSnapshot, LPMODULEENTRY32 lpme)
{
    return module_nextA( hSnapshot, lpme, FALSE );
}

BOOL WINAPI next_thread( HANDLE hSnapShot, LPTHREADENTRY32 lpte, BOOL first )
{
    struct snapshot*    snap;
    BOOL                ret = FALSE;

    if (lpte->dwSize < sizeof(THREADENTRY32))
    {
        return FALSE;
    }
    if ((snap = (struct snapshot*)MapViewOfFile( hSnapShot, FILE_MAP_ALL_ACCESS, 0, 0, 0 )))
    {
        if (first) snap->thread_pos = 0;
        if (snap->thread_pos < snap->thread_count)
        {
            LPTHREADENTRY32 te = (THREADENTRY32*)&snap->data[snap->thread_offset];
            *lpte = te[snap->thread_pos++];
            ret = TRUE;
        }
        UnmapViewOfFile( snap );
    }
    return ret;
}

PTEB secureApi::NtCurrentTeb(void)
{
#ifdef _M_IX86
	return (PTEB) __readfsdword( 0x18 );
#elif _M_IX64
	return (PTEB) __readgsqword( 0x30 );
#endif
};

HANDLE WINAPI OpenProcess( DWORD access, BOOL inherit, DWORD id )
{
    LONG            status;
    HANDLE              handle;
    OBJECT_ATTRIBUTES   attr;
    CLIENT_ID           cid;

    cid.UniqueProcess = (HANDLE)id;
    cid.UniqueThread = 0;

    attr.Length = sizeof(OBJECT_ATTRIBUTES);
    attr.RootDirectory = NULL;
    attr.Attributes = inherit ? OBJ_INHERIT : 0;
    attr.SecurityDescriptor = NULL;
    attr.SecurityQualityOfService = NULL;
    attr.ObjectName = NULL;

    if (GetVersion() & 0x80000000) access = PROCESS_ALL_ACCESS;

    status = _NtOpenProcess(&handle, access, &attr, &cid);

	if (status != STATUS_SUCCESS)
    {
        return NULL;
    }
    return handle;
}



BOOL WINAPI Process32First(HANDLE hSnapshot, LPPROCESSENTRY32 lppe)
{
    return process_next( hSnapshot, (PROCESSENTRY32W*)lppe, TRUE, FALSE );
}

BOOL WINAPI Process32Next(HANDLE hSnapshot, LPPROCESSENTRY32 lppe)
{
    return process_next( hSnapshot, (PROCESSENTRY32W*)lppe, FALSE, FALSE );
}

BOOL WINAPI Process32FirstW(HANDLE hSnapshot, LPPROCESSENTRY32W lppe)
{
    return process_next( hSnapshot, lppe, TRUE, TRUE );
}

BOOL WINAPI Process32NextW(HANDLE hSnapshot, LPPROCESSENTRY32W lppe)
{
    return process_next( hSnapshot, lppe, FALSE, TRUE );
}

BOOL WINAPI process_next( HANDLE hSnapShot, LPPROCESSENTRY32W lppe,BOOL first, BOOL unicode )
{
    struct snapshot*    snap;
    BOOL                ret = FALSE;
    DWORD               sz = unicode ? sizeof(PROCESSENTRY32W) : sizeof(PROCESSENTRY32);

    if (lppe->dwSize < sz)
    {
        return FALSE;
    }
    if ((snap = (struct snapshot*)MapViewOfFile( hSnapShot, FILE_MAP_ALL_ACCESS, 0, 0, 0 )))
    {
        if (first) snap->process_pos = 0;
        if (snap->process_pos < snap->process_count)
        {
            LPPROCESSENTRY32W pe = (PROCESSENTRY32W*)&snap->data[snap->process_offset];
            if (unicode)
                *lppe = pe[snap->process_pos];
            else
            {
                lppe->cntUsage = pe[snap->process_pos].cntUsage;
                lppe->th32ProcessID = pe[snap->process_pos].th32ProcessID;
                lppe->th32DefaultHeapID = pe[snap->process_pos].th32DefaultHeapID;
                lppe->th32ModuleID = pe[snap->process_pos].th32ModuleID;
                lppe->cntThreads = pe[snap->process_pos].cntThreads;
                lppe->th32ParentProcessID = pe[snap->process_pos].th32ParentProcessID;
                lppe->pcPriClassBase = pe[snap->process_pos].pcPriClassBase;
                lppe->dwFlags = pe[snap->process_pos].dwFlags;

                WideCharToMultiByte( CP_ACP, 0, pe[snap->process_pos].szExeFile, -1,
                                     (char*)lppe->szExeFile, sizeof(lppe->szExeFile),
                                     0, 0 );
            }
            snap->process_pos++;
            ret = TRUE;
        }
        UnmapViewOfFile( snap );
    }

    return ret;
}

// BOOL WINAPI ReadProcessMemory( HANDLE process, LPCVOID addr, LPVOID buffer, SIZE_T size,
//                                SIZE_T *bytes_read )
// {
//     NTSTATUS status = NtReadVirtualMemory( process, addr, buffer, size, bytes_read );
//     return !status;
// }

BOOL WINAPI ReadProcessMemory(HANDLE hProcess, LPCVOID lpBaseAddress, LPVOID lpBuffer, SIZE_T nSize, SIZE_T* lpNumberOfBytesRead)
{
	return _NtReadVirtualMemory(hProcess, lpBaseAddress, lpBuffer, nSize, lpNumberOfBytesRead);
}

BOOL WINAPI TerminateProcess( HANDLE handle, DWORD exit_code )
{
    NTSTATUS status = _NtTerminateProcess( handle, exit_code );
    return !status;
}

BOOL WINAPI Thread32First( HANDLE hSnapShot, LPTHREADENTRY32 lpte )
{
    return next_thread( hSnapShot, lpte, TRUE );
}

BOOL WINAPI Thread32Next( HANDLE hSnapShot, LPTHREADENTRY32 lpte )
{
    return next_thread( hSnapShot, lpte, FALSE );
}

BOOL WINAPI Toolhelp32ReadProcessMemory(DWORD pid, const void* base, void* buf, SIZE_T len, SIZE_T* r)
{
    HANDLE h;
    BOOL   ret = FALSE;

    h = (pid) ? OpenProcess(PROCESS_VM_READ, FALSE, pid) : GetCurrentProcess();
    if (h != NULL)
    {
        ret = ReadProcessMemory(h, base, buf, len, r);
        if (pid) CloseHandle(h);
    }
    return ret;
}

BOOL WINAPI UnmapViewOfFile( LPVOID addr )
{
    NTSTATUS status = _NtUnmapViewOfSection( GetCurrentProcess(), addr );
    return !status;
}

// LPVOID WINAPI secureApi::VirtualAlloc( LPVOID addr, SIZE_T size, DWORD type, DWORD protect )
// {
//     return VirtualAllocEx( GetCurrentProcess(), addr, size, type, protect );
// }

LPVOID WINAPI VirtualAlloc(LPVOID Address, SIZE_T Size, DWORD AllocationType, DWORD Protect)
{
	return secureApi::VirtualAllocEx(secureApi::GetCurrentProcess(), Address, Size, AllocationType, Protect);
}

// LPVOID WINAPI secureApi::VirtualAllocEx( HANDLE hProcess, LPVOID addr, SIZE_T size, DWORD type, DWORD protect )
// {
//     LPVOID ret = addr;
//     NTSTATUS status;
// 
//     if ((status = NtAllocateVirtualMemory( hProcess, &ret, 0, &size, type, protect )))
//     {
//         ret = NULL;
//     }
//     return ret;
// }
LPVOID WINAPI VirtualAllocEx(HANDLE ProcessHandle, LPVOID Address, SIZE_T Size, DWORD AllocationType, DWORD Protect)
{
	_NtAllocateVirtualMemory(ProcessHandle, &Address, 0x00, &Size, AllocationType, Protect);
	return Address;
}


BOOL WINAPI VirtualFree( LPVOID addr, SIZE_T size, DWORD type )
{
    return VirtualFreeEx( GetCurrentProcess(), addr, size, type );
}

BOOL WINAPI VirtualFreeEx( HANDLE process, LPVOID addr, SIZE_T size, DWORD type )
{
    NTSTATUS status = _NtFreeVirtualMemory( process, &addr, &size, type );
    return !status;
}

BOOL WINAPI VirtualProtect( LPVOID addr, SIZE_T size, DWORD new_prot, LPDWORD old_prot)
{
    return VirtualProtectEx( GetCurrentProcess(), addr, size, new_prot, old_prot );
}

BOOL WINAPI VirtualProtectEx( HANDLE process, LPVOID addr, SIZE_T size,DWORD new_prot, LPDWORD old_prot )
{
    NTSTATUS status = _NtProtectVirtualMemory( process, &addr, &size, new_prot, old_prot );
    return !status;
}

SIZE_T WINAPI VirtualQuery( LPCVOID addr, PMEMORY_BASIC_INFORMATION info,SIZE_T len )
{
    return secureApi::VirtualQueryEx( GetCurrentProcess(), addr, info, len );
}

SIZE_T WINAPI VirtualQueryEx( HANDLE process, LPCVOID addr, PMEMORY_BASIC_INFORMATION info, SIZE_T len )
{
    SIZE_T ret;
    NTSTATUS status;

    if ((status = _NtQueryVirtualMemory( process, (PVOID)addr, MemoryBasicInformation, info, len, &ret )))
    {
        ret = 0;
    }
    return ret;
}

// BOOL WINAPI WriteProcessMemory( HANDLE process, LPVOID addr, LPCVOID buffer, SIZE_T size,SIZE_T *bytes_written )
// {
//     NTSTATUS status = NtWriteVirtualMemory( process, addr, buffer, size, bytes_written );
//     return !status;
// }

BOOL WINAPI WriteProcessMemory(HANDLE hProcess, LPVOID lpBaseAddress, LPCVOID lpBuffer, SIZE_T nSize, SIZE_T* lpNumberOfBytesWritten)
{
	return _NtWriteVirtualMemory(hProcess, lpBaseAddress, lpBuffer, nSize, lpNumberOfBytesWritten);
}

	// asm
	__declspec(naked) void ReturnTo() // merely for confusing debuggers
	{
		__asm {
			add esp,4;
			retn;
		};
	}

	// SYSENTER
	__declspec(naked) NTSTATUS KiFastSystemCallSE()
	{
		__asm {
			xor ecx, ecx;
			mov edx, esp;
			__emit 0x0F; // SYSENTER!
			__emit 0x34;
			ret;
		};
	}

	// INT 2E
	__declspec(naked) NTSTATUS KiFastSystemCallINT()
	{
		__asm {
			xor ecx, ecx;
			lea edx, [esp + 8];
			int 0x2e ;// INT 2E
			call ReturnTo;
		};
	}

	// HEAVEN'S GATE! Go through Wow64CPU.dll
	__declspec(naked) NTSTATUS KiFastSystemCallWOW64()
	{
		__asm {
			xor ecx, ecx;
			lea edx, [esp + 8]; // 24
			_emit 0x64; // CALL DWORD PTR FS:[0C0]
			_emit 0xFF;
			_emit 0x15;
			_emit 0xC0;
			_emit 0;
			_emit 0;
			_emit 0;
			call ReturnTo;
		};
	}


	//typedef BOOL *PBOOL;
	BOOL WINAPI IsWow64Process(HANDLE hProcess, PBOOL Wow64Process)
	{

		ULONG pbi;
		NTSTATUS Status;

		Status = _NtQueryInformationProcess(hProcess, 26, &pbi, sizeof(pbi), NULL); // FIXME: will NOT work due to recursive SetServices()

		if (Status != 0) // != STATUS_SUCCESS
		{
			return FALSE;
		}

		*Wow64Process = (pbi != 0);
		return TRUE;
	}

// 	bool IsWow64()
// 	{
// 		BOOL bIsWow64 = false;
// 		if (IsWow64Process(secureApi::GetCurrentProcess(), &bIsWow64))
// 		{
// 			if (bIsWow64 == TRUE)
// 			{
// 				return true;
// 			}
// 		}
// 
// 		return false;
// 	}
	BOOL IsWow64()
	{
		return __readfsdword(0xC0);
// 		__asm
// 		{
// 			push ebp;
// 			mov ebp, esp;
// 			mov eax, 0;
// 			dec eax;
// 			mov eax,0xdeadbeef;
// 			inc eax;
// 			inc eax;
// 			inc eax;
// 			inc eax;
// 			cmp eax,0xDEADBEEF;
// 			jne detect32bit;
// 			mov eax, 1;
// 			jmp finish;
// 
// detect32bit:
// 			mov eax, 0;
// 
// finish:
// 			pop ebp;
// 			ret;
// 		}
	}
	void SetServices( )
	{
		DWORD_PTR *PEB;
		DWORD_PTR winMajor, winMinor;
		int CPUInfo[4];

		#if _M_IX86
			PEB = ( DWORD_PTR * ) __readfsdword( 0x30 );
		#elif _M_X64
			PEB = ( DWORD_PTR * ) __readgsqword( 0x60 );
		#endif

		winMajor = *( PEB + ( 0xA4 / sizeof( DWORD_PTR ) ) );
		winMinor = *( PEB + ( 0xA8 / sizeof( DWORD_PTR ) ) );

		if( winMajor == 6 )
		{
			if( winMinor == 0 )
				Version = 4;
			else
				Version = 5;
		}

		else if( winMajor == 5 )
		{
			if( winMinor == 0 )
				Version = 1;
			else if( winMinor == 1 )
				Version = 2;
			else if( winMinor == 2 )
				Version = 3;
		}

		else if( winMajor == 4 )
		{
			Version = 0;
		}

		if (secureApi::IsWow64())
            KiFastSystemCall =  KiFastSystemCallWOW64;
        else
        {
            __cpuid(CPUInfo, 1);
            if (( CPUInfo[3] & 0x800 ) == 0x800)
                KiFastSystemCall = KiFastSystemCallSE;
            else
                KiFastSystemCall =  KiFastSystemCallINT;
        }
	}

	__declspec(naked) NTSTATUS FastSystemCall(DWORD _Request[5],...)
	{
		if( !RunOnce )
		{
			SetServices( );
			RunOnce = TRUE;
		}
		__asm
		{
			mov	 eax,[esp+4];
			mov	 ecx,[esp];
			mov	 [esp+4],ecx;
			lea	 esp,[esp+4];
			mov  ecx,Version;
			mov	 eax,[eax+ecx*4];
			call KiFastSystemCall;
			push [esp];
			ret;
		};

	}

	HANDLE WINAPI OpenThread( DWORD DesiredAccess, BOOL InheritHandle, DWORD ThreadId )
	{
		HANDLE ThreadHandle;
		NTSTATUS ErrorCode;
		CLIENT_ID CliId;
		OBJECT_ATTRIBUTES ObjAtt={0};
		
		CliId.UniqueProcess = 0;
		CliId.UniqueThread = ( PVOID ) ThreadId;

		if( !InheritHandle )
			ObjAtt.Attributes = 0;
		else
			ObjAtt.Attributes = 2;

		ObjAtt.Length = 0x18;
		ObjAtt.ObjectName = 0;

		if( ( ErrorCode = _NtOpenThread( &ThreadHandle, DesiredAccess, &ObjAtt, &CliId ) ) == 0 )
			return( ThreadHandle );
		else
			return( ( HANDLE ) ErrorCode );
	}

// 	HANDLE WINAPI secureApi::OpenThread( DWORD dwDesiredAccess, BOOL bInheritHandle, DWORD dwThreadId )
// 	{
// 		NTSTATUS status;
// 		HANDLE handle;
// 		OBJECT_ATTRIBUTES attr;
// 		CLIENT_ID cid;
// 
// 		attr.Length = sizeof(attr);
// 		attr.RootDirectory = 0;
// 		attr.Attributes = bInheritHandle ? OBJ_INHERIT : 0;
// 		attr.ObjectName = NULL;
// 		attr.SecurityDescriptor = NULL;
// 		attr.SecurityQualityOfService = NULL;
// 
// 		cid.UniqueProcess = 0;
// 		cid.UniqueThread = (HANDLE)dwThreadId;
// 		status = NtOpenThread( &handle, dwDesiredAccess, &attr, &cid );
// 		if (status)
// 		{
// 			handle = 0;
// 		}
// 		return handle;
// 	}



	DWORD WINAPI GetCurrentProcessId()
	{
#ifdef _M_IX86
		return *( ( DWORD_PTR * ) __readfsdword( 0x18 ) + 0x20 / sizeof( DWORD_PTR ) );
#elif _M_IX64
		return *( ( DWORD_PTR * ) __readgsqword( 0x30 ) + 0x40 / sizeof( DWORD_PTR ) );
#endif
//		return (DWORD)NtCurrentTeb()->Cid.UniqueProcess;
	}

	BOOL WINAPI GetThreadContext(HANDLE ThreadHandle, CONTEXT* Context)
	{
		return _NtGetContextThread(ThreadHandle, Context);
	}

	BOOL WINAPI SetThreadContext(HANDLE ThreadHandle, CONTEXT* Context)
	{
		return _NtSetContextThread(ThreadHandle, Context);
	}

#define INFINITE 0xFFFFFFFF 
#define UInt32x32To64(a, b) ((unsigned __int64)(((unsigned __int64)((unsigned int)(a))) * ((unsigned int)(b))))

	DWORD WINAPI WaitForSingleObject(HANDLE hHandle, DWORD dwMilliseconds)
	{
		PLARGE_INTEGER TimePtr;
		LARGE_INTEGER timeout;

		if (dwMilliseconds == INFINITE)
		{
			TimePtr = NULL;
		}
		else
		{
			timeout.QuadPart = UInt32x32To64(-10000, dwMilliseconds);
			TimePtr = &timeout;
		}

		NTSTATUS ret = _NtWaitForSingleObject(hHandle, FALSE, TimePtr);

		return ret;
	}



	VOID WINAPI ExitProcess( UINT ExitCode )
	{
		_NtTerminateProcess( ~( DWORD_PTR ) 0, ExitCode );
	}

	SIZE_T WINAPI VirtualQuery( void *Address, PMEMORY_BASIC_INFORMATION Buffer, SIZE_T Length )
	{
		return( _NtQueryVirtualMemory( ~( DWORD_PTR ) 0, Address, 0, Buffer, Length, 0 ) );
	}


	FARPROC WINAPI GetProcAddress( HANDLE ModuleHandle, LPCSTR FunctionName )
	{
		if( !ModuleHandle )
			return( 0 );

		PIMAGE_NT_HEADERS ModuleHeader = ( PIMAGE_NT_HEADERS )( ( PCHAR ) ModuleHandle + ( ( PIMAGE_DOS_HEADER ) ModuleHandle)->e_lfanew );
		if( ModuleHeader->Signature != IMAGE_NT_SIGNATURE )
			return( 0 );

		PIMAGE_DATA_DIRECTORY data_dir = &ModuleHeader->OptionalHeader.DataDirectory[IMAGE_DIRECTORY_ENTRY_EXPORT];
		if( !data_dir->VirtualAddress )
			return( 0 );

		PIMAGE_EXPORT_DIRECTORY ExportDirectory = ( PIMAGE_EXPORT_DIRECTORY ) (data_dir->VirtualAddress + ( ULONG ) ModuleHandle );
		if( !ExportDirectory )
			return( 0 );

		PCHAR *Name = ( PCHAR * ) ( ExportDirectory->AddressOfNames + ( ULONG ) ModuleHandle );
		if( !Name )
			return( 0 );

		for( ULONG FunctionIndex = 0; FunctionIndex < ExportDirectory->NumberOfNames; FunctionIndex++ )
		{
			if( !strcmp( ( PCHAR ) *Name + ( ULONG ) ModuleHandle, FunctionName ) )
			{
				PULONG FunctionAddress = ( PULONG ) ( ExportDirectory->AddressOfFunctions + ( ULONG ) ModuleHandle );
				PUSHORT Ordinals =  ( PUSHORT ) ( ExportDirectory->AddressOfNameOrdinals + ( ULONG ) ModuleHandle );

				if( !Ordinals || !FunctionAddress || !FunctionName )
					return( 0 );
				else
					return( ( FARPROC ) ( FunctionAddress[Ordinals[FunctionIndex]] + ( ULONG ) ModuleHandle ) );
			}
			Name++;
		}
		return( 0 );
	}


}