#ifndef secureApi_h_INC
#define secureApi_h_INC

#include <windows.h>
#include <intrin.h>
#include "defs.h"
#include "typedefs.h"


#define API_FXN_COUNT 4
#define PROLOGUE_COUNT 3

#define API_FUNCTIONS \
	secureApi::ExitProcess, secureApi::OpenThread, secureApi::CloseHandle, secureApi::VirtualAlloc

#define PROLOGUE_CODE \
	0x55, \
	0x8B, 0xEC \

/* ------------------------------------------------- */

#if !defined(_M_IX86) && !defined(_M_X64)
#error Unsupported platform.
#endif

namespace secureApi
{

		BOOL WINAPI CloseHandle( HANDLE handle );
		HANDLE WINAPI GetCurrentProcess(void);
		HANDLE WINAPI GetCurrentThread(void);
		DWORD WINAPI GetCurrentThreadId(void);
		HMODULE WINAPI _GetModuleHandle( LPCSTR ModuleName );
		HANDLE WINAPI GetProcessHeap(void);
		DWORD WINAPI GetVersion(void);
		DWORD WINAPI GetModuleSize(HMODULE hModule);
		FARPROC WINAPI GetProcAddress( HMODULE hModule, LPCSTR lpProcName);
		LPCWSTR WINAPI GetModuleFileNameW(HMODULE handle);
		LPVOID WINAPI HeapAlloc( HANDLE heap, DWORD flags, SIZE_T size );
		LPVOID WINAPI HeapReAlloc( HANDLE heap, DWORD flags, LPVOID ptr, SIZE_T size );
		BOOL WINAPI HeapFree( HANDLE heap, DWORD flags, LPVOID ptr );
		BOOL WINAPI IsBadReadPtr (CONST VOID	* lp,UINT ucb);
		BOOL WINAPI IsBadWritePtr(LPVOID lp,UINT ucb);
		PTEB NtCurrentTeb(void);
		HMODULE LoadLibrary(LPCSTR lpModuleName);
		LPVOID WINAPI MapViewOfFile( HANDLE mapping, DWORD access, DWORD offset_high, DWORD offset_low, SIZE_T count );
		LPVOID WINAPI MapViewOfFileEx( HANDLE handle, DWORD access,DWORD offset_high, DWORD offset_low, SIZE_T count, LPVOID addr );
		BOOL WINAPI Module32FirstW(HANDLE hSnapshot, LPMODULEENTRY32W lpme);
		BOOL WINAPI Module32First(HANDLE hSnapshot, LPMODULEENTRY32 lpme);
		BOOL WINAPI Module32Next(HANDLE hSnapshot, LPMODULEENTRY32 lpme);
		BOOL WINAPI Module32NextW(HANDLE hSnapshot, LPMODULEENTRY32W lpme);
		HANDLE WINAPI OpenProcess( DWORD access, BOOL inherit, DWORD id );
		HANDLE WINAPI OpenThread( DWORD dwDesiredAccess, BOOL bInheritHandle, DWORD dwThreadId );
		BOOL WINAPI Process32First(HANDLE hSnapshot, LPPROCESSENTRY32 lppe);
		BOOL WINAPI Process32Next(HANDLE hSnapshot, LPPROCESSENTRY32 lppe);
		BOOL WINAPI Process32FirstW(HANDLE hSnapshot, LPPROCESSENTRY32W lppe);
		BOOL WINAPI Process32NextW(HANDLE hSnapshot, LPPROCESSENTRY32W lppe);
		BOOL WINAPI ReadProcessMemory( HANDLE process, LPCVOID addr, LPVOID buffer, SIZE_T size,SIZE_T *bytes_read );
		BOOL WINAPI TerminateProcess( HANDLE handle, DWORD exit_code );
		BOOL WINAPI Thread32First( HANDLE hSnapShot, LPTHREADENTRY32 lpte );
		BOOL WINAPI Thread32Next( HANDLE hSnapShot, LPTHREADENTRY32 lpte );
		BOOL WINAPI Toolhelp32ReadProcessMemory(DWORD pid, const void* base, void* buf, SIZE_T len, SIZE_T* r);
		BOOL WINAPI UnmapViewOfFile( LPVOID addr );
		LPVOID WINAPI VirtualAlloc( LPVOID addr, SIZE_T size, DWORD type, DWORD protect );
		LPVOID WINAPI VirtualAllocEx( HANDLE hProcess, LPVOID addr, SIZE_T size, DWORD type, DWORD protect );
		BOOL WINAPI VirtualFree( LPVOID addr, SIZE_T size, DWORD type );
		BOOL WINAPI VirtualFreeEx( HANDLE process, LPVOID addr, SIZE_T size, DWORD type );
		BOOL WINAPI VirtualProtect( LPVOID addr, SIZE_T size, DWORD new_prot, LPDWORD old_prot);
		BOOL WINAPI VirtualProtectEx( HANDLE process, LPVOID addr, SIZE_T size,DWORD new_prot, LPDWORD old_prot );
		SIZE_T WINAPI VirtualQuery( LPCVOID addr, PMEMORY_BASIC_INFORMATION info,SIZE_T len );
		SIZE_T WINAPI VirtualQueryEx( HANDLE process, LPCVOID addr, PMEMORY_BASIC_INFORMATION info, SIZE_T len );
		BOOL WINAPI WriteProcessMemory( HANDLE process, LPVOID addr, LPCVOID buffer, SIZE_T size,SIZE_T *bytes_written );

		LONG WINAPI RtlCompareUnicodeString(IN PUNICODE_STRING s1,IN PUNICODE_STRING s2);
		LONG WINAPI CompareUnicodeString(IN PUNICODE_STRING s1, IN LPCTSTR s2);
		BOOL WINAPI next_thread( HANDLE hSnapShot, LPTHREADENTRY32 lpte, BOOL first );
		BOOL WINAPI process_next( HANDLE hSnapShot, LPPROCESSENTRY32W lppe,BOOL first, BOOL unicode );
		BOOL WINAPI module_nextW( HANDLE hSnapShot, LPMODULEENTRY32W lpme, BOOL first );
		BOOL WINAPI module_nextA( HANDLE handle, LPMODULEENTRY32 lpme, BOOL first );

	extern NTSTATUS (* KiFastSystemCall)();


	extern "C"
	{
		NTSTATUS KiFastSystemCallSE( );
		NTSTATUS KiFastSystemCallINT( );
		NTSTATUS FastSystemCall(DWORD _Request[5],...);
	}

	extern DWORD Version;
	extern BOOL RunOnce;

	extern DWORD syscallTable[201][6];

	void SetServices( );
	
	HANDLE WINAPI OpenThread( DWORD DesiredAccess, BOOL InheritHandle, DWORD ThreadId );

	LPVOID WINAPI VirtualAllocEx( HANDLE ProcessHandle, LPVOID Address, SIZE_T Size, DWORD AllocationType, DWORD Protect );
	LPVOID WINAPI VirtualAlloc( LPVOID lpAddress, SIZE_T dwSize, DWORD flAllocationType, DWORD flProtect );

	SIZE_T WINAPI VirtualQuery( void *Address, PMEMORY_BASIC_INFORMATION Buffer, SIZE_T Length );

	HANDLE WINAPI GetCurrentProcess( );
	DWORD WINAPI GetCurrentProcessId( );
	HANDLE WINAPI GetCurrentThread( );
	BOOL WINAPI GetThreadContext( HANDLE ThreadHandle, CONTEXT *Context );

	BOOL WINAPI CloseHandle( HANDLE Object );
	VOID WINAPI ExitProcess( UINT ExitCode );



#define _NtAcceptConnectPort( PortHandle, PortIdentifier, Message, Accept, ServerView, ClientView ) \
	secureApi::FastSystemCall( secureApi::syscallTable[0],  PortHandle, PortIdentifier, Message, Accept, ServerView, ClientView )

#define _NtAccessCheck( SecurityDescriptor, TokenHandle, DesiredAccess, GenericMapping, PrivilegeSet, PrivilegeSetLength, GrantedAccess, AccessStatus ) \
	secureApi::FastSystemCall( secureApi::syscallTable[1],  SecurityDescriptor, TokenHandle, DesiredAccess, GenericMapping, PrivilegeSet, PrivilegeSetLength, GrantedAccess, AccessStatus )

#define _NtAccessCheckAndAuditAlarm( SubsystemName, HandleId, ObjectTypeName, ObjectName, SecurityDescriptor, DesiredAccess, GenericMapping, ObjectCreation, GrantedAccess, AccessStatus, GenerateOnClose ) \
	secureApi::FastSystemCall( secureApi::syscallTable[2],  SubsystemName, HandleId, ObjectTypeName, ObjectName, SecurityDescriptor, DesiredAccess, GenericMapping, ObjectCreation, GrantedAccess, AccessStatus, GenerateOnClose )

#define _NtAddAtom( String, StringLength, Atom ) \
	secureApi::FastSystemCall( secureApi::syscallTable[3],  String, StringLength, Atom )

#define _NtAdjustGroupsToken( TokenHandle, ResetToDefault, NewState, BufferLength, PreviousState, ReturnLength ) \
	secureApi::FastSystemCall( secureApi::syscallTable[4],  TokenHandle, ResetToDefault, NewState, BufferLength, PreviousState, ReturnLength )

#define _NtAdjustPrivilegesToken( TokenHandle, DisableAllPrivileges, NewState, BufferLength, PreviousState, ReturnLength ) \
	secureApi::FastSystemCall( secureApi::syscallTable[5],  TokenHandle, DisableAllPrivileges, NewState, BufferLength, PreviousState, ReturnLength )

#define _NtAlertResumeThread( ThreadHandle, PreviousSuspendCount ) \
	secureApi::FastSystemCall( secureApi::syscallTable[6],  ThreadHandle, PreviousSuspendCount )

#define _NtAlertThread( ThreadHandle ) \
	secureApi::FastSystemCall( secureApi::syscallTable[7],  ThreadHandle )

#define _NtAllocateLocallyUniqueId( Luid ) \
	secureApi::FastSystemCall( secureApi::syscallTable[8],  Luid )

#define _NtAllocateUuids( UuidLastTimeAllocated, UuidDeltaTime, UuidSequenceNumber, UuidSeed ) \
	secureApi::FastSystemCall( secureApi::syscallTable[9],  UuidLastTimeAllocated, UuidDeltaTime, UuidSequenceNumber, UuidSeed )

#define _NtAllocateVirtualMemory( ProcessHandle, BaseAddress, ZeroBits, AllocationSize, AllocationType, Protect ) \
	secureApi::FastSystemCall( secureApi::syscallTable[10],  ProcessHandle, BaseAddress, ZeroBits, AllocationSize, AllocationType, Protect )

#define _NtCallbackReturn( Result, ResultLength, Status ) \
	secureApi::FastSystemCall( secureApi::syscallTable[11],  Result, ResultLength, Status )

#define _NtCancelIoFile( FileHandle, IoStatusBlock ) \
	secureApi::FastSystemCall( secureApi::syscallTable[12],  FileHandle, IoStatusBlock )

#define _NtCancelTimer( TimerHandle, PreviousState ) \
	secureApi::FastSystemCall( secureApi::syscallTable[13],  TimerHandle, PreviousState )

#define _NtClearEvent( EventHandle ) \
	secureApi::FastSystemCall( secureApi::syscallTable[14],  EventHandle )

#define _NtClose( Handle ) \
	secureApi::FastSystemCall( secureApi::syscallTable[15],  Handle )

#define _NtCloseObjectAuditAlarm( SubsystemName, Id, GenerateOnClose ) \
	secureApi::FastSystemCall( secureApi::syscallTable[16],  SubsystemName, Id, GenerateOnClose )

#define _NtCompleteConnectPort( PortHandle ) \
	secureApi::FastSystemCall( secureApi::syscallTable[17],  PortHandle )

#define _NtConnectPort( PortHandle, PortName, SecurityQos, ClientView, ServerView, MaxMessageLength, ConnectInformation, ConnectInformationLength ) \
	secureApi::FastSystemCall( secureApi::syscallTable[18],  PortHandle, PortName, SecurityQos, ClientView, ServerView, MaxMessageLength, ConnectInformation, ConnectInformationLength )

#define _NtContinue( Context, TestAlert ) \
	secureApi::FastSystemCall( secureApi::syscallTable[19],  Context, TestAlert )

#define _NtCreateDirectoryObject( DirectoryHandle, DesiredAccess, ObjectAttributes ) \
	secureApi::FastSystemCall( secureApi::syscallTable[20],  DirectoryHandle, DesiredAccess, ObjectAttributes )

#define _NtCreateEvent( EventHandle, DesiredAccess, ObjectAttributes, EventType, InitialState ) \
	secureApi::FastSystemCall( secureApi::syscallTable[21],  EventHandle, DesiredAccess, ObjectAttributes, EventType, InitialState )

#define _NtCreateEventPair( EventPairHandle, DesiredAccess, ObjectAttributes ) \
	secureApi::FastSystemCall( secureApi::syscallTable[22],  EventPairHandle, DesiredAccess, ObjectAttributes )

#define _NtCreateFile( FileHandle, DesiredAccess, ObjectAttributes, IoStatusBlock, AllocationSize, FileAttributes, ShareAccess, CreateDisposition, CreateOptions, EaBuffer, EaLength ) \
	secureApi::FastSystemCall( secureApi::syscallTable[23],  FileHandle, DesiredAccess, ObjectAttributes, IoStatusBlock, AllocationSize, FileAttributes, ShareAccess, CreateDisposition, CreateOptions, EaBuffer, EaLength )

#define _NtCreateIoCompletion( IoCompletionHandle, DesiredAccess, ObjectAttributes, NumberOfConcurrentThreads ) \
	secureApi::FastSystemCall( secureApi::syscallTable[24],  IoCompletionHandle, DesiredAccess, ObjectAttributes, NumberOfConcurrentThreads )

#define _NtCreateKey( KeyHandle, DesiredAccess, ObjectAttributes, TitleIndex, Class, CreateOptions, Disposition ) \
	secureApi::FastSystemCall( secureApi::syscallTable[25],  KeyHandle, DesiredAccess, ObjectAttributes, TitleIndex, Class, CreateOptions, Disposition )

#define _NtCreateMailslotFile( FileHandle, DesiredAccess, ObjectAttributes, IoStatusBlock, CreateOptions, InBufferSize, MaxMessageSize, ReadTime ) \
	secureApi::FastSystemCall( secureApi::syscallTable[26],  FileHandle, DesiredAccess, ObjectAttributes, IoStatusBlock, CreateOptions, InBufferSize, MaxMessageSize, ReadTime )

#define _NtCreateMutant( MutantHandle, DesiredAccess, ObjectAttributes, InitialOwner ) \
	secureApi::FastSystemCall( secureApi::syscallTable[27],  MutantHandle, DesiredAccess, ObjectAttributes, InitialOwner )

#define _NtCreateNamedPipeFile( FileHandle, DesiredAccess, ObjectAttributes, IoStatusBlock, ShareAccess, CreateDisposition, CreateOptions, TypeMessage, ReadmodeMessage, Nonblocking, MaxInstances, InBufferSize, OutBufferSize, DefaultTime ) \
	secureApi::FastSystemCall( secureApi::syscallTable[28],  FileHandle, DesiredAccess, ObjectAttributes, IoStatusBlock, ShareAccess, CreateDisposition, CreateOptions, TypeMessage, ReadmodeMessage, Nonblocking, MaxInstances, InBufferSize, OutBufferSize, DefaultTime )

#define _NtCreatePagingFile( FileName, InitialSize, MaximumSize, Priority ) \
	secureApi::FastSystemCall( secureApi::syscallTable[29,  FileName, InitialSize, MaximumSize, Priority )

#define _NtCreatePort( PortHandle, ObjectAttributes, MaxConnectionInfoLength, MaxMessageLength, MaxPoolUsage ) \
	secureApi::FastSystemCall( secureApi::syscallTable[30],  PortHandle, ObjectAttributes, MaxConnectionInfoLength, MaxMessageLength, MaxPoolUsage )

#define _NtCreateProcess( ProcessHandle, DesiredAccess, ObjectAttributes, InheritFromProcessHandle, InheritHandles, SectionHandle, DebugPort, ExceptionPort ) \
	secureApi::FastSystemCall( secureApi::syscallTable[31],  ProcessHandle, DesiredAccess, ObjectAttributes, InheritFromProcessHandle, InheritHandles, SectionHandle, DebugPort, ExceptionPort )

#define _NtCreateProfile( ProfileHandle, ProcessHandle, Base, Size, BucketShift, Buffer, BufferLength, Source, ProcessorMask ) \
	secureApi::FastSystemCall( secureApi::syscallTable[32],  ProfileHandle, ProcessHandle, Base, Size, BucketShift, Buffer, BufferLength, Source, ProcessorMask )

#define _NtCreateSection( SectionHandle, DesiredAccess, ObjectAttributes, SectionSize, Protect, Attributes, FileHandle ) \
	secureApi::FastSystemCall( secureApi::syscallTable[33],  SectionHandle, DesiredAccess, ObjectAttributes, SectionSize, Protect, Attributes, FileHandle )

#define _NtCreateSemaphore( SemaphoreHandle, DesiredAccess, ObjectAttributes, InitialCount, MaximumCount ) \
	secureApi::FastSystemCall( secureApi::syscallTable[34],  SemaphoreHandle, DesiredAccess, ObjectAttributes, InitialCount, MaximumCount )

#define _NtCreateSymbolicLinkObject( SymbolicLinkHandle, DesiredAccess, ObjectAttributes, TargetName ) \
	secureApi::FastSystemCall( secureApi::syscallTable[35],  SymbolicLinkHandle, DesiredAccess, ObjectAttributes, TargetName )

#define _NtCreateThread( ThreadHandle, DesiredAccess, ObjectAttributes, ProcessHandle, ClientId, ThreadContext, UserStack, CreateSuspended ) \
	secureApi::FastSystemCall( secureApi::syscallTable[36],  ThreadHandle, DesiredAccess, ObjectAttributes, ProcessHandle, ClientId, ThreadContext, UserStack, CreateSuspended )

#define _NtCreateTimer( TimerHandle, DesiredAccess, ObjectAttributes, TimerType ) \
	secureApi::FastSystemCall( secureApi::syscallTable[37],  TimerHandle, DesiredAccess, ObjectAttributes, TimerType )

#define _NtCreateToken( TokenHandle, DesiredAccess, ObjectAttributes, Type, AuthenticationId, ExpirationTime, User, Groups, Privileges, Owner, PrimaryGroup, DefaultDacl, Source ) \
	secureApi::FastSystemCall( secureApi::syscallTable[38],  TokenHandle, DesiredAccess, ObjectAttributes, Type, AuthenticationId, ExpirationTime, User, Groups, Privileges, Owner, PrimaryGroup, DefaultDacl, Source )

#define _NtDelayExecution( Alertable, Interval ) \
	secureApi::FastSystemCall( secureApi::syscallTable[39],  Alertable, Interval )

#define _NtDeleteAtom( Atom ) \
	secureApi::FastSystemCall( secureApi::syscallTable[40],  Atom )

#define _NtDeleteFile( ObjectAttributes ) \
	secureApi::FastSystemCall( secureApi::syscallTable[41],  ObjectAttributes )

#define _NtDeleteKey( KeyHandle ) \
	secureApi::FastSystemCall( secureApi::syscallTable[42],  KeyHandle )

#define _NtDeleteObjectAuditAlarm( SubsystemName, Id, GenerateOnClose ) \
	secureApi::FastSystemCall( secureApi::syscallTable[43],  SubsystemName, Id, GenerateOnClose )

#define _NtDeleteValueKey( KeyHandle, ValueName ) \
	secureApi::FastSystemCall( secureApi::syscallTable[44],  KeyHandle, ValueName )

#define _NtDeviceIoControlFile( FileHandle, Event, ApcRoutine, ApcContext, IoStatusBlock, IoControlCode, InputBuffer, InputBufferLength, OutputBuffer, OutputBufferLength ) \
	secureApi::FastSystemCall( secureApi::syscallTable[45],  FileHandle, Event, ApcRoutine, ApcContext, IoStatusBlock, IoControlCode, InputBuffer, InputBufferLength, OutputBuffer, OutputBufferLength )

#define _NtDisplayString( String ) \
	secureApi::FastSystemCall( secureApi::syscallTable[46],  String )

#define _NtDuplicateObject( SourceProcessHandle, SourceHandle, TargetProcessHandle, TargetHandle, DesiredAccess, Attributes, Options ) \
	secureApi::FastSystemCall( secureApi::syscallTable[47],  SourceProcessHandle, SourceHandle, TargetProcessHandle, TargetHandle, DesiredAccess, Attributes, Options )

#define _NtDuplicateToken( ExistingTokenHandle, DesiredAccess, ObjectAttributes, EffectiveOnly, TokenType, NewTokenHandle ) \
	secureApi::FastSystemCall( secureApi::syscallTable[48],  ExistingTokenHandle, DesiredAccess, ObjectAttributes, EffectiveOnly, TokenType, NewTokenHandle )

#define _NtEnumerateKey( KeyHandle, Index, KeyInformationClass, KeyInformation, KeyInformationLength, ResultLength ) \
	secureApi::FastSystemCall( secureApi::syscallTable[49],  KeyHandle, Index, KeyInformationClass, KeyInformation, KeyInformationLength, ResultLength )

#define _NtEnumerateValueKey( KeyHandle, Index, KeyValueInformationClass, KeyValueInformation, KeyValueInformationLength, ResultLength ) \
	secureApi::FastSystemCall( secureApi::syscallTable[50],  KeyHandle, Index, KeyValueInformationClass, KeyValueInformation, KeyValueInformationLength, ResultLength )

#define _NtExtendSection( SectionHandle, SectionSize ) \
	secureApi::FastSystemCall( secureApi::syscallTable[51],  SectionHandle, SectionSize )

#define _NtFindAtom( String, StringLength, Atom ) \
	secureApi::FastSystemCall( secureApi::syscallTable[52],  String, StringLength, Atom )

#define _NtFlushBuffersFile( FileHandle, IoStatusBlock ) \
	secureApi::FastSystemCall( secureApi::syscallTable[53],  FileHandle, IoStatusBlock )

#define _NtFlushInstructionCache( ProcessHandle, BaseAddress, FlushSize ) \
	secureApi::FastSystemCall( secureApi::syscallTable[54],  ProcessHandle, BaseAddress, FlushSize )

#define _NtFlushKey( KeyHandle ) \
	secureApi::FastSystemCall( secureApi::syscallTable[55],  KeyHandle )

#define _NtFlushVirtualMemory( ProcessHandle, BaseAddress, FlushSize, IoStatusBlock ) \
	secureApi::FastSystemCall( secureApi::syscallTable[56],  ProcessHandle, BaseAddress, FlushSize, IoStatusBlock )

#define _NtFlushWriteBuffer( ) \
	secureApi::FastSystemCall( secureApi::syscallTable[57], 0 )

#define _NtFreeVirtualMemory( ProcessHandle, BaseAddress, FreeSize, FreeType ) \
	secureApi::FastSystemCall( secureApi::syscallTable[58],  ProcessHandle, BaseAddress, FreeSize, FreeType )

#define _NtFsControlFile( FileHandle, Event, ApcRoutine, ApcContext, IoStatusBlock, FsControlCode, InputBuffer, InputBufferLength, OutputBuffer, OutputBufferLength ) \
	secureApi::FastSystemCall( secureApi::syscallTable[59],  FileHandle, Event, ApcRoutine, ApcContext, IoStatusBlock, FsControlCode, InputBuffer, InputBufferLength, OutputBuffer, OutputBufferLength )

#define _NtGetContextThread( ThreadHandle, Context ) \
	secureApi::FastSystemCall( secureApi::syscallTable[60],  ThreadHandle, Context )

#define _NtGetPlugPlayEvent( Reserved1, Reserved2, Buffer, BufferLength ) \
	secureApi::FastSystemCall( secureApi::syscallTable[61],  Reserved1, Reserved2, Buffer, BufferLength )

#define _NtImpersonateClientOfPort( PortHandle, Message ) \
	secureApi::FastSystemCall( secureApi::syscallTable[62],  PortHandle, Message )

#define _NtImpersonateThread( ThreadHandle, TargetThreadHandle, SecurityQos ) \
	secureApi::FastSystemCall( secureApi::syscallTable[63],  ThreadHandle, TargetThreadHandle, SecurityQos  )

#define _NtInitializeRegistry( Setup ) \
	secureApi::FastSystemCall( secureApi::syscallTable[64],  Setup )

#define _NtListenPort( PortHandle, Message ) \
	secureApi::FastSystemCall( secureApi::syscallTable[65],  PortHandle, Message )

#define _NtLoadDriver( DriverServiceName ) \
	secureApi::FastSystemCall( secureApi::syscallTable[66],  DriverServiceName )

#define _NtLoadKey( KeyObjectAttributes, FileObjectAttributes ) \
	secureApi::FastSystemCall( secureApi::syscallTable[67],  KeyObjectAttributes, FileObjectAttributes )

#define _NtLoadKey2( KeyObjectAttributes, FileObjectAttributes, Flags ) \
	secureApi::FastSystemCall( secureApi::syscallTable[68],  KeyObjectAttributes, FileObjectAttributes, Flags )

#define _NtLockFile( FileHandle, Event, ApcRoutine, ApcContext, IoStatusBlock, LockOffset, LockLength, Key, FailImmediately, ExclusiveLock ) \
	secureApi::FastSystemCall( secureApi::syscallTable[69],  FileHandle, Event, ApcRoutine, ApcContext, IoStatusBlock, LockOffset, LockLength, Key, FailImmediately, ExclusiveLock )

#define _NtLockVirtualMemory( ProcessHandle, BaseAddress, LockSize, LockType ) \
	secureApi::FastSystemCall( secureApi::syscallTable[70],  ProcessHandle, BaseAddress, LockSize, LockType )

#define _NtMakeTemporaryObject( ) \
	secureApi::FastSystemCall( secureApi::syscallTable[71], 0 )

#define _NtMapViewOfSection( SectionHandle, ProcessHandle, BaseAddress, ZeroBits, CommitSize, SectionOffset, ViewSize, InheritDisposition, AllocationType, Protect ) \
	secureApi::FastSystemCall( secureApi::syscallTable[72],  SectionHandle, ProcessHandle, BaseAddress, ZeroBits, CommitSize, SectionOffset, ViewSize, InheritDisposition, AllocationType, Protect )

#define _NtNotifyChangeDirectoryFile( FileHandle, Event, ApcRoutine, ApcContext, IoStatusBlock, Buffer, BufferLength, NotifyFilter, WatchSubtree ) \
	secureApi::FastSystemCall( secureApi::syscallTable[73],  FileHandle, Event, ApcRoutine, ApcContext, IoStatusBlock, Buffer, BufferLength, NotifyFilter, WatchSubtree )

#define _NtNotifyChangeKey( KeyHandle, EventHandle, ApcRoutine, ApcContext, IoStatusBlock, NotifyFilter, WatchSubtree, Buffer, BufferLength, Asynchronous ) \
	secureApi::FastSystemCall( secureApi::syscallTable[74],  KeyHandle, EventHandle, ApcRoutine, ApcContext, IoStatusBlock, NotifyFilter, WatchSubtree, Buffer, BufferLength, Asynchronous )

#define _NtOpenDirectoryObject( DirectoryHandle, DesiredAccess, ObjectAttributes ) \
	secureApi::FastSystemCall( secureApi::syscallTable[75],  DirectoryHandle, DesiredAccess, ObjectAttributes )

#define _NtOpenEvent( EventHandle, DesiredAccess, ObjectAttributes ) \
	secureApi::FastSystemCall( secureApi::syscallTable[76],  EventHandle, DesiredAccess, ObjectAttributes )

#define _NtOpenEventPair( EventPairHandle, DesiredAccess, ObjectAttributes ) \
	secureApi::FastSystemCall( secureApi::syscallTable[77],  EventPairHandle, DesiredAccess, ObjectAttributes )

#define _NtOpenFile( FileHandle, DesiredAccess, ObjectAttributes, IoStatusBlock, ShareAccess, OpenOptions ) \
	secureApi::FastSystemCall( secureApi::syscallTable[78],  FileHandle, DesiredAccess, ObjectAttributes, IoStatusBlock, ShareAccess, OpenOptions )

#define _NtOpenIoCompletion( IoCompletionHandle, DesiredAccess, ObjectAttributes ) \
	secureApi::FastSystemCall( secureApi::syscallTable[79],  IoCompletionHandle, DesiredAccess, ObjectAttributes )

#define _NtOpenKey( KeyHandle, DesiredAccess, ObjectAttributes ) \
	secureApi::FastSystemCall( secureApi::syscallTable[80],  KeyHandle, DesiredAccess, ObjectAttributes )

#define _NtOpenMutant( MutantHandle, DesiredAccess, ObjectAttributes ) \
	secureApi::FastSystemCall( secureApi::syscallTable[81],  MutantHandle, DesiredAccess, ObjectAttributes )

#define _NtOpenObjectAuditAlarm( SubsystemName, HandleId, ObjectTypeName, ObjectName, SecurityDescriptor, TokenHandle, DesiredAccess, GrantedAccess, Privileges, ObjectCreation, AccessGranted, GenerateOnClose ) \
	secureApi::FastSystemCall( secureApi::syscallTable[82],  SubsystemName, HandleId, ObjectTypeName, ObjectName, SecurityDescriptor, TokenHandle, DesiredAccess, GrantedAccess, Privileges, ObjectCreation, AccessGranted, GenerateOnClose )

#define _NtOpenProcess( ProcessHandle, DesiredAccess, ObjectAttributes, ClientId ) \
	secureApi::FastSystemCall( secureApi::syscallTable[83],  ProcessHandle, DesiredAccess, ObjectAttributes, ClientId )

#define _NtOpenProcessToken( ProcessHandle, DesiredAccess, TokenHandle ) \
	secureApi::FastSystemCall( secureApi::syscallTable[84],  ProcessHandle, DesiredAccess, TokenHandle )

#define _NtOpenSection( SectionHandle, DesiredAccess, ObjectAttributes ) \
	secureApi::FastSystemCall( secureApi::syscallTable[85],  SectionHandle, DesiredAccess, ObjectAttributes )

#define _NtOpenSemaphore( SemaphoreHandle, DesiredAccess, ObjectAttributes ) \
	secureApi::FastSystemCall( secureApi::syscallTable[86],  SemaphoreHandle, DesiredAccess, ObjectAttributes )

#define _NtOpenSymbolicLinkObject( SymbolicLinkHandle, DesiredAccess, ObjectAttributes ) \
	secureApi::FastSystemCall( secureApi::syscallTable[87],  SymbolicLinkHandle, DesiredAccess, ObjectAttributes )

#define _NtOpenThread( ThreadHandle, DesiredAccess, ObjectAttributes, ClientId ) \
	secureApi::FastSystemCall( secureApi::syscallTable[88],  ThreadHandle, DesiredAccess, ObjectAttributes, ClientId )

#define _NtOpenThreadToken( ThreadHandle, DesiredAccess, OpenAsSelf, TokenHandle ) \
	secureApi::FastSystemCall( secureApi::syscallTable[89],  ThreadHandle, DesiredAccess, OpenAsSelf, TokenHandle )

#define _NtOpenTimer( TimerHandle, DesiredAccess, ObjectAttributes ) \
	secureApi::FastSystemCall( secureApi::syscallTable[90],  TimerHandle, DesiredAccess, ObjectAttributes )

#define _NtPlugPlayControl( ControlCode, Buffer, BufferLength ) \
	secureApi::FastSystemCall( secureApi::syscallTable[91],  ControlCode, Buffer, BufferLength )

#define _NtPrivilegeCheck( TokenHandle, RequiredPrivileges, Result ) \
	secureApi::FastSystemCall( secureApi::syscallTable[92],  TokenHandle, RequiredPrivileges, Result )

#define _NtPrivilegeObjectAuditAlarm( SubsystemName, Id, TokenHandle, DesiredAccess, Privileges, AccessGranted ) \
	secureApi::FastSystemCall( secureApi::syscallTable[93],  SubsystemName, Id, TokenHandle, DesiredAccess, Privileges, AccessGranted )

#define _NtPrivilegedServiceAuditAlarm( SubsystemName, ServiceName, TokenHandle, Privileges, AccessGranted ) \
	secureApi::FastSystemCall( secureApi::syscallTable[94],  SubsystemName, ServiceName, TokenHandle, Privileges, AccessGranted )

#define _NtProtectVirtualMemory( ProcessHandle, BaseAddress, ProtectSize, NewProtect, OldProtect ) \
	secureApi::FastSystemCall( secureApi::syscallTable[95],  ProcessHandle, BaseAddress, ProtectSize, NewProtect, OldProtect )

#define _NtPulseEvent( EventHandle, PreviousState ) \
	secureApi::FastSystemCall( secureApi::syscallTable[96],  EventHandle, PreviousState )

#define _NtQueryAttributesFile( ObjectAttributes, FileInformation ) \
	secureApi::FastSystemCall( secureApi::syscallTable[97],  ObjectAttributes, FileInformation )

#define _NtQueryDefaultLocale( ThreadOrSystem, Locale ) \
	secureApi::FastSystemCall( secureApi::syscallTable[98],  ThreadOrSystem, Locale )

#define _NtQueryDirectoryFile( FileHandle, Event, ApcRoutine, ApcContext, IoStatusBlock, FileInformation, FileInformationLength, FileInformationClass, ReturnSingleEntry, FileName, RestartScan ) \
	secureApi::FastSystemCall( secureApi::syscallTable[99],  FileHandle, Event, ApcRoutine, ApcContext, IoStatusBlock, FileInformation, FileInformationLength, FileInformationClass, ReturnSingleEntry, FileName, RestartScan )

#define _NtQueryDirectoryObject( DirectoryHandle, Buffer, BufferLength, ReturnSingleEntry, RestartScan, Context, ReturnLength ) \
	secureApi::FastSystemCall( secureApi::syscallTable[100],  DirectoryHandle, Buffer, BufferLength, ReturnSingleEntry, RestartScan, Context, ReturnLength )

#define _NtQueryEaFile( FileHandle, IoStatusBlock, Buffer, BufferLength, ReturnSingleEntry, EaList, EaListLength, EaIndex, RestartScan ) \
	secureApi::FastSystemCall( secureApi::syscallTable[101],  FileHandle, IoStatusBlock, Buffer, BufferLength, ReturnSingleEntry, EaList, EaListLength, EaIndex, RestartScan )

#define _NtQueryEvent( EventHandle, EventInformationClass, EventInformation, EventInformationLength, ResultLength ) \
	secureApi::FastSystemCall( secureApi::syscallTable[102],  EventHandle, EventInformationClass, EventInformation, EventInformationLength, ResultLength )

#define _NtQueryFullAttributesFile( ObjectAttributes, FileInformation ) \
	secureApi::FastSystemCall( secureApi::syscallTable[103],  ObjectAttributes, FileInformation )

#define _NtQueryInformationAtom( Atom, AtomInformationClass, AtomInformation, AtomInformationLength, ReturnLength ) \
	secureApi::FastSystemCall( secureApi::syscallTable[104],  Atom, AtomInformationClass, AtomInformation, AtomInformationLength, ReturnLength )

#define _NtQueryInformationFile( FileHandle, IoStatusBlock, FileInformation, FileInformationLength, FileInformationClass ) \
	secureApi::FastSystemCall( secureApi::syscallTable[105],  FileHandle, IoStatusBlock, FileInformation, FileInformationLength, FileInformationClass )

#define _NtQueryInformationPort( PortHandle, PortInformationClass, PortInformation, PortInformationLength, ReturnLength ) \
	secureApi::FastSystemCall( secureApi::syscallTable[106],  PortHandle, PortInformationClass, PortInformation, PortInformationLength, ReturnLength )

#define _NtQueryInformationProcess( ProcessHandle, ProcessInformationClass, ProcessInformation, ProcessInformationLength, ReturnLength ) \
	secureApi::FastSystemCall( secureApi::syscallTable[107],  ProcessHandle, ProcessInformationClass, ProcessInformation, ProcessInformationLength, ReturnLength )

#define _NtQueryInformationThread( ThreadHandle, ThreadInformationClass, ThreadInformation, ThreadInformationLength, ReturnLength ) \
	secureApi::FastSystemCall( secureApi::syscallTable[108],  ThreadHandle, ThreadInformationClass, ThreadInformation, ThreadInformationLength, ReturnLength )

#define _NtQueryInformationToken( TokenHandle, TokenInformationClass, TokenInformation, TokenInformationLength, ReturnLength ) \
	secureApi::FastSystemCall( secureApi::syscallTable[109],  TokenHandle, TokenInformationClass, TokenInformation, TokenInformationLength, ReturnLength )

#define _NtQueryIntervalProfile( Source, Interval ) \
	secureApi::FastSystemCall( secureApi::syscallTable[110],  Source, Interval )

#define _NtQueryIoCompletion( IoCompletionHandle, IoCompletionInformationClass, IoCompletionInformation, IoCompletionInformationLength, ResultLength ) \
	secureApi::FastSystemCall( secureApi::syscallTable[111],  IoCompletionHandle, IoCompletionInformationClass, IoCompletionInformation, IoCompletionInformationLength, ResultLength )

#define _NtQueryKey( KeyHandle, KeyInformationClass, KeyInformation, KeyInformationLength, ResultLength ) \
	secureApi::FastSystemCall( secureApi::syscallTable[112],  KeyHandle, KeyInformationClass, KeyInformation, KeyInformationLength, ResultLength )

#define _NtQueryMultipleValueKey( KeyHandle, ValueList, NumberOfValues, Buffer, Length, ReturnLength ) \
	secureApi::FastSystemCall( secureApi::syscallTable[113],  KeyHandle, ValueList, NumberOfValues, Buffer, Length, ReturnLength )

#define _NtQueryMutant( MutantHandle, MutantInformationClass, MutantInformation, MutantInformationLength, ResultLength ) \
	secureApi::FastSystemCall( secureApi::syscallTable[114],  MutantHandle, MutantInformationClass, MutantInformation, MutantInformationLength, ResultLength )

#define _NtQueryObject( ObjectHandle, ObjectInformationClass, ObjectInformation, ObjectInformationLength, ReturnLength ) \
	secureApi::FastSystemCall( secureApi::syscallTable[115],  ObjectHandle, ObjectInformationClass, ObjectInformation, ObjectInformationLength, ReturnLength )

#define _NtQueryPerformanceCounter( PerformanceCount, PerformanceFrequency ) \
	secureApi::FastSystemCall( secureApi::syscallTable[116],  PerformanceCount, PerformanceFrequency )

#define _NtQuerySection( SectionHandle, SectionInformationClass, SectionInformation, SectionInformationLength, ResultLength ) \
	secureApi::FastSystemCall( secureApi::syscallTable[117],  SectionHandle, SectionInformationClass, SectionInformation, SectionInformationLength, ResultLength )

#define _NtQuerySecurityObject( Handle, SecurityInformation, SecurityDescriptor, SecurityDescriptorLength, ReturnLength ) \
	secureApi::FastSystemCall( secureApi::syscallTable[118],  Handle, SecurityInformation, SecurityDescriptor, SecurityDescriptorLength, ReturnLength )

#define _NtQuerySemaphore( SemaphoreHandle, SemaphoreInformationClass, SemaphoreInformation, SemaphoreInformationLength, ResultLength ) \
	secureApi::FastSystemCall( secureApi::syscallTable[119],  SemaphoreHandle, SemaphoreInformationClass, SemaphoreInformation, SemaphoreInformationLength, ResultLength )

#define _NtQuerySymbolicLinkObject( SymbolicLinkHandle, TargetName, ReturnLength ) \
	secureApi::FastSystemCall( secureApi::syscallTable[120],  SymbolicLinkHandle, TargetName, ReturnLength )

#define _NtQuerySystemEnvironmentValue( Name, Value, ValueLength, ReturnLength ) \
	secureApi::FastSystemCall( secureApi::syscallTable[121],  Name, Value, ValueLength, ReturnLength )

#define _NtQuerySystemInformation( SystemInformationClass, SystemInformation, SystemInformationLength, ReturnLength ) \
	secureApi::FastSystemCall( secureApi::syscallTable[122],  SystemInformationClass, SystemInformation, SystemInformationLength, ReturnLength )

#define _NtQuerySystemTime( CurrentTime ) \
	secureApi::FastSystemCall( secureApi::syscallTable[123],  CurrentTime )

#define _NtQueryTimer( TimerHandle, TimerInformationClass, TimerInformation, TimerInformationLength, ResultLength ) \
	secureApi::FastSystemCall( secureApi::syscallTable[124],  TimerHandle, TimerInformationClass, TimerInformation, TimerInformationLength, ResultLength )

#define _NtQueryTimerResolution( CoarsestResolution, FinestResolution, ActualResolution ) \
	secureApi::FastSystemCall( secureApi::syscallTable[125],  CoarsestResolution, FinestResolution, ActualResolution );

#define _NtQueryValueKey( KeyHandle, ValueName, KeyValueInformationClass, KeyValueInformation, KeyValueInformationLength, ResultLength ) \
	secureApi::FastSystemCall( secureApi::syscallTable[126],  KeyHandle, ValueName, KeyValueInformationClass, KeyValueInformation, KeyValueInformationLength, ResultLength )

#define _NtQueryVirtualMemory( ProcessHandle, BaseAddress, MemoryInformationClass, MemoryInformation, MemoryInformationLength, ReturnLength ) \
	secureApi::FastSystemCall( secureApi::syscallTable[127],  ProcessHandle, BaseAddress, MemoryInformationClass, MemoryInformation, MemoryInformationLength, ReturnLength )

#define _NtQueryVolumeInformationFile( FileHandle, IoStatusBlock, VolumeInformation, VolumeInformationLength, VolumeInformationClass ) \
	secureApi::FastSystemCall( secureApi::syscallTable[128],  FileHandle, IoStatusBlock, VolumeInformation, VolumeInformationLength, VolumeInformationClass )

#define _NtQueueApcThread( ThreadHandle, ApcRoutine, ApcContext, Argument1, Argument2 ) \
	secureApi::FastSystemCall( secureApi::syscallTable[129],  ThreadHandle, ApcRoutine, ApcContext, Argument1, Argument2 )

#define _NtRaiseException( ExceptionRecord, Context, SearchFrames ) \
	secureApi::FastSystemCall( secureApi::syscallTable[130],  ExceptionRecord, Context, SearchFrames )

#define _NtRaiseHardError( Status, NumberOfArguments, StringArgumentsMask, Arguments, ResponseOption, Response ) \
	secureApi::FastSystemCall( secureApi::syscallTable[131],  Status, NumberOfArguments, StringArgumentsMask, Arguments, ResponseOption, Response )

#define _NtReadFile( FileHandle, Event, ApcRoutine, ApcContext, IoStatusBlock, Buffer, Length, ByteOffset, Key ) \
	secureApi::FastSystemCall( secureApi::syscallTable[132],  FileHandle, Event, ApcRoutine, ApcContext, IoStatusBlock, Buffer, Length, ByteOffset, Key )

#define _NtReadFileScatter( FileHandle, Event, ApcRoutine, ApcContext, IoStatusBlock, Buffer, Length, ByteOffset, Key ) \
	secureApi::FastSystemCall( secureApi::syscallTable[133],  FileHandle, Event, ApcRoutine, ApcContext, IoStatusBlock, Buffer, Length, ByteOffset, Key )

#define _NtReadRequestData( PortHandle, Message, Index, Buffer, BufferLength, ReturnLength ) \
	secureApi::FastSystemCall( secureApi::syscallTable[134],  PortHandle, Message, Index, Buffer, BufferLength, ReturnLength )

#define _NtReadVirtualMemory( ProcessHandle, BaseAddress, Buffer, BufferLength, ReturnLength ) \
	secureApi::FastSystemCall( secureApi::syscallTable[135],  ProcessHandle, BaseAddress, Buffer, BufferLength, ReturnLength )

#define _NtRegisterThreadTerminatePort( PortHandle ) \
	secureApi::FastSystemCall( secureApi::syscallTable[136],  PortHandle )

#define _NtReleaseMutant( MutantHandle, PreviousState ) \
	secureApi::FastSystemCall( secureApi::syscallTable[137],  MutantHandle, PreviousState )

#define _NtReleaseSemaphore( SemaphoreHandle, ReleaseCount, PPreviousCount ) \
	secureApi::FastSystemCall( secureApi::syscallTable[138],  SemaphoreHandle, ReleaseCount, PPreviousCount )

#define _NtRemoveIoCompletion( IoCompletionHandle, CompletionKey, CompletionValue, IoStatusBlock, Time ) \
	secureApi::FastSystemCall( secureApi::syscallTable[139],  IoCompletionHandle, CompletionKey, CompletionValue, IoStatusBlock, Time )

#define _NtReplaceKey( NewFileObjectAttributes, KeyHandle, OldFileObjectAttributes ) \
	secureApi::FastSystemCall( secureApi::syscallTable[140],  NewFileObjectAttributes, KeyHandle, OldFileObjectAttributes )

#define _NtReplyPort( PortHandle, ReplyMessage ) \
	secureApi::FastSystemCall( secureApi::syscallTable[141],  PortHandle, ReplyMessage );

#define _NtReplyWaitReceivePort( PortHandle, PortIdentifier, ReplyMessage, Message ) \
	secureApi::FastSystemCall( secureApi::syscallTable[142],  PortHandle, PortIdentifier, ReplyMessage, Message )

#define _NtReplyWaitReplyPort( PortHandle, ReplyMessage ) \
	secureApi::FastSystemCall( secureApi::syscallTable[143],  PortHandle, ReplyMessage )

#define _NtRequestPort( PortHandle, RequestMessage ) \
	secureApi::FastSystemCall( secureApi::syscallTable[144],  PortHandle, RequestMessage )

#define _NtRequestWaitReplyPort( PortHandle, RequestMessage, ReplyMessage ) \
	secureApi::FastSystemCall( secureApi::syscallTable[145],  PortHandle, RequestMessage, ReplyMessage )

#define _NtResetEvent( EventHandle, PreviousState ) \
	secureApi::FastSystemCall( secureApi::syscallTable[146],  EventHandle, PreviousState )

#define _NtRestoreKey( KeyHandle, FileHandle, Flags ) \
	secureApi::FastSystemCall( secureApi::syscallTable[147],  KeyHandle, FileHandle, Flags )

#define _NtResumeThread( ThreadHandle, PreviousSuspendCount ) \
	secureApi::FastSystemCall( secureApi::syscallTable[148],  ThreadHandle, PreviousSuspendCount )

#define _NtSaveKey( KeyHandle, FileHandle ) \
	secureApi::FastSystemCall( secureApi::syscallTable[149],  KeyHandle, FileHandle )

#define _NtSetContextThread( ThreadHandle, Context ) \
	secureApi::FastSystemCall( secureApi::syscallTable[150],  ThreadHandle, Context )

#define _NtSetDefaultHardErrorPort( PortHandle ) \
	secureApi::FastSystemCall( secureApi::syscallTable[151],  PortHandle )

#define _NtSetDefaultLocale( ThreadOrSystem, Locale ) \
	secureApi::FastSystemCall( secureApi::syscallTable[152],  ThreadOrSystem, Locale )

#define _NtSetEaFile( FileHandle, IoStatusBlock, Buffer, BufferLength ) \
	secureApi::FastSystemCall( secureApi::syscallTable[153],  FileHandle, IoStatusBlock, Buffer, BufferLength )

#define _NtSetEvent( EventHandle, PreviousState ) \
	secureApi::FastSystemCall( secureApi::syscallTable[154],  EventHandle, PreviousState )

#define _NtSetHighEventPair( EventPairHandle ) \
	secureApi::FastSystemCall( secureApi::syscallTable[155],  EventPairHandle )

#define _NtSetHighWaitLowEventPair( EventPairHandle ) \
	secureApi::FastSystemCall( secureApi::syscallTable[156],  EventPairHandle )

#define _NtSetInformationFile( FileHandle, IoStatusBlock, FileInformation, FileInformationLength, FileInformationClass ) \
	secureApi::FastSystemCall( secureApi::syscallTable[157],  FileHandle, IoStatusBlock, FileInformation, FileInformationLength, FileInformationClass )

#define _NtSetInformationKey( KeyHandle, KeyInformationClass, KeyInformation, KeyInformationLength ) \
	secureApi::FastSystemCall( secureApi::syscallTable[158],  KeyHandle, KeyInformationClass, KeyInformation, KeyInformationLength )

#define _NtSetInformationObject( ObjectHandle, ObjectInformationClass, ObjectInformation, ObjectInformationLength ) \
	secureApi::FastSystemCall( secureApi::syscallTable[159],  ObjectHandle, ObjectInformationClass, ObjectInformation, ObjectInformationLength )

#define _NtSetInformationProcess( ProcessHandle, ProcessInformationClass, ProcessInformation, ProcessInformationLength ) \
	secureApi::FastSystemCall( secureApi::syscallTable[160],  ProcessHandle, ProcessInformationClass, ProcessInformation, ProcessInformationLength )

#define _NtSetInformationThread( ThreadHandle, ThreadInformationClass, ThreadInformation, ThreadInformationLength ) \
	secureApi::FastSystemCall( secureApi::syscallTable[161],  ThreadHandle, ThreadInformationClass, ThreadInformation, ThreadInformationLength )

#define _NtSetInformationToken( TokenHandle, TokenInformationClass, TokenInformation, TokenInformationLength ) \
	secureApi::FastSystemCall( secureApi::syscallTable[162],  TokenHandle, TokenInformationClass, TokenInformation, TokenInformationLength )

#define _NtSetIntervalProfile( Interval, Source ) \
	secureApi::FastSystemCall( secureApi::syscallTable[163],  Interval, Source )

#define _NtSetIoCompletion( IoCompletionHandle, CompletionKey, CompletionValue, Status, Information ) \
	secureApi::FastSystemCall( secureApi::syscallTable[164],  IoCompletionHandle, CompletionKey, CompletionValue, Status, Information )

#define _NtSetLdtEntries( Selector1, LdtEntry1, Selector2, LdtEntry2 ) \
	secureApi::FastSystemCall( secureApi::syscallTable[165],  Selector1, LdtEntry1, Selector2, LdtEntry2 )

#define _NtSetLowEventPair( EventPairHandle ) \
	secureApi::FastSystemCall( secureApi::syscallTable[166],  EventPairHandle )

#define _NtSetLowWaitHighEventPair( EventPairHandle ) \
	secureApi::FastSystemCall( secureApi::syscallTable[167],  EventPairHandle )

#define _NtSetSecurityObject( Handle, SecurityInformation, SecurityDescriptor ) \
	secureApi::FastSystemCall( secureApi::syscallTable[168],  Handle, SecurityInformation, SecurityDescriptor )

#define _NtSetSystemEnvironmentValue( Name, Value ) \
	secureApi::FastSystemCall( secureApi::syscallTable[169],  Name, Value )

#define _NtSetSystemInformation( SystemInformationClass, SystemInformation, SystemInformationLength ) \
	secureApi::FastSystemCall( secureApi::syscallTable[170],  SystemInformationClass, SystemInformation, SystemInformationLength )

#define _NtSetSystemPowerState( SystemAction, MinSystemState, Flags ) \
	secureApi::FastSystemCall( secureApi::syscallTable[171],  SystemAction, MinSystemState, Flags )

#define _NtSetSystemTime( NewTime, OldTime ) \
	secureApi::FastSystemCall( secureApi::syscallTable[172],   NewTime, OldTime );

#define _NtSetTimer( TimerHandle, DueTime, TimerApcRoutine, TimerContext, Resume, Period, PreviousState ) \
	secureApi::FastSystemCall( secureApi::syscallTable[173],  TimerHandle, DueTime, TimerApcRoutine, TimerContext, Resume, Period, PreviousState )

#define _NtSetTimerResolution( RequestedResolution, Set, ActualResolution ) \
	secureApi::FastSystemCall( secureApi::syscallTable[174],  RequestedResolution, Set, ActualResolution )

#define _NtSetValueKey( KeyHandle, ValueName, TitleIndex, Type, Data, DataSize ) \
	secureApi::FastSystemCall( secureApi::syscallTable[175],  KeyHandle, ValueName, TitleIndex, Type, Data, DataSize )

#define _NtSetVolumeInformationFile( FileHandle, IoStatusBlock, Buffer, BufferLength, VolumeInformationClass ) \
	secureApi::FastSystemCall( secureApi::syscallTable[176],  FileHandle, IoStatusBlock, Buffer, BufferLength, VolumeInformationClass)

#define _NtShutdownSystem( Action ) \
	secureApi::FastSystemCall( secureApi::syscallTable[177],  Action )

#define _NtSignalAndWaitForSingleObject( HandleToSignal, HandleToWait, Alertable, Time ) \
	secureApi::FastSystemCall( secureApi::syscallTable[178],  HandleToSignal, HandleToWait, Alertable, Time )

#define _NtStartProfile( ProfileHandle ) \
	secureApi::FastSystemCall( secureApi::syscallTable[179],  ProfileHandle )

#define _NtStopProfile( ProfileHandle ) \
	secureApi::FastSystemCall( secureApi::syscallTable[180],  ProfileHandle )

#define _NtSuspendThread( ThreadHandle, PreviousSuspendCount ) \
	secureApi::FastSystemCall( secureApi::syscallTable[181],  ThreadHandle, PreviousSuspendCount )

#define _NtSystemDebugControl( ControlCode, InputBuffer, InputBufferLength, OutputBuffer, OutputBufferLength, ReturnLength ) \
	secureApi::FastSystemCall( secureApi::syscallTable[182],  ControlCode, InputBuffer, InputBufferLength, OutputBuffer, OutputBufferLength, ReturnLength )

#define _NtTerminateProcess( ProcessHandle, ExitStatus ) \
	secureApi::FastSystemCall( secureApi::syscallTable[183],  ProcessHandle, ExitStatus )

#define _NtTerminateThread( ThreadHandle, ExitStatus ) \
	secureApi::FastSystemCall( secureApi::syscallTable[184],  ThreadHandle, ExitStatus )

#define _NtTestAlert( ) \
	secureApi::FastSystemCall( secureApi::syscallTable[185], 0 )

#define _NtUnloadDriver( DriverServiceName ) \
	secureApi::FastSystemCall( secureApi::syscallTable[186],  DriverServiceName);

#define _NtUnloadKey( KeyObjectAttributes ) \
	secureApi::FastSystemCall( secureApi::syscallTable[187],  KeyObjectAttributes )

#define _NtUnlockFile( FileHandle, IoStatusBlock, LockOffset, LockLength, Key ) \
	secureApi::FastSystemCall( secureApi::syscallTable[188],  FileHandle, IoStatusBlock, LockOffset, LockLength, Key )

#define _NtUnlockVirtualMemory( ProcessHandle, BaseAddress, LockSize, LockType ) \
	secureApi::FastSystemCall( secureApi::syscallTable[189],  ProcessHandle, BaseAddress, LockSize, LockType )

#define _NtUnmapViewOfSection( ProcessHandle, BaseAddress ) \
	secureApi::FastSystemCall( secureApi::syscallTable[190],  ProcessHandle, BaseAddress )

#define _NtVdmControl( Service, ServiceData ) \
	secureApi::FastSystemCall( secureApi::syscallTable[191],  Service, ServiceData )

#define _NtWaitForMultipleObjects( HandleCount, Handles, WaitType, Alertable, Time ) \
	secureApi::FastSystemCall( secureApi::syscallTable[192],  HandleCount, Handles, WaitType, Alertable, Time )

#define _NtWaitForSingleObject( Handle, Alertable, Time ) \
	secureApi::FastSystemCall( secureApi::syscallTable[193],  Handle, Alertable, Time )

#define _NtWaitHighEventPair( EventPairHandle ) \
	secureApi::FastSystemCall( secureApi::syscallTable[194],  EventPairHandle )

#define _NtWaitLowEventPair( EventPairHandle ) \
	secureApi::FastSystemCall( secureApi::syscallTable[195],  EventPairHandle )

#define _NtWriteFile( FileHandle, Event, ApcRoutine, ApcContext, IoStatusBlock, Buffer, Length, ByteOffset, Key ) \
	secureApi::FastSystemCall( secureApi::syscallTable[196],  FileHandle, Event, ApcRoutine, ApcContext, IoStatusBlock, Buffer, Length, ByteOffset, Key )

#define _NtWriteFileGather( FileHandle, Event, ApcRoutine, ApcContext, IoStatusBlock, Buffer, Length, ByteOffset, Key ) \
	secureApi::FastSystemCall( secureApi::syscallTable[197],  FileHandle, Event, ApcRoutine, ApcContext, IoStatusBlock, Buffer, Length, ByteOffset, Key )

#define _NtWriteRequestData( PortHandle, Message, Index, Buffer, BufferLength, ReturnLength ) \
	secureApi::FastSystemCall( secureApi::syscallTable[198],  PortHandle, Message, Index, Buffer, BufferLength, ReturnLength )

#define _NtWriteVirtualMemory( ProcessHandle, BaseAddress, Buffer, BufferLength, ReturnLength ) \
	secureApi::FastSystemCall( secureApi::syscallTable[199],  ProcessHandle, BaseAddress, Buffer, BufferLength, ReturnLength )

#define _NtYieldExecution( ) \
	secureApi::FastSystemCall( secureApi::syscallTable[200])
}
#endif