#include "secureApi.h"
#pragma comment( linker, "/SUBSYSTEM:WINDOWS" )
#pragma comment( linker, "/ENTRY:main" )

#define CODEBEGIN		0x00401000
#define CODEEND			0x00401854

#ifdef _M_IX86
	#define MODBEGIN		0x70000000
	#define MODEND			0x7FFFFFFF
#elif _M_IX64
	#define MODBEGIN		0x7000000000000000
	#define MODEND			0x7FFFFFFFFFFFFFFF
#endif

DWORD GetThreadStartAddress( HANDLE ThreadHandle )
{
	DWORD StartAddress = 0;

	_NtQueryInformationThread( ThreadHandle, 9, &StartAddress, sizeof( DWORD ), 0 );

	if( !StartAddress )
		_NtQueryInformationThread( ThreadHandle, 8, &StartAddress, sizeof( DWORD ), 0 );

	return( StartAddress );
}

// Checking the instruction pointer is removed temporarily,
// because imports are made to MSVCR functions when using a CONTEXT variable.
DWORD EnumerateThreads( DWORD ProcessId )
{
	PVOID *SysProcess = ( PVOID * ) 0;
	HANDLE ThreadHandle = 0;

	
	CONTEXT ctx;
	ctx.ContextFlags = CONTEXT_FULL;

	DWORD BadThreadCount = 0;
	DWORD ThreadStartAddress = 0;
	DWORD ThreadIP = 0;

	SYSTEM_PROCESS_INFORMATION *CurrProcess;

	SysProcess = (PVOID *)secureApi::VirtualAlloc(NULL, 0x100000, 0x1000, 0x04 );

	NTSTATUS status = _NtQuerySystemInformation(SystemProcessInformation, SysProcess, 0x100000,0);
	if (status!=STATUS_SUCCESS)
	{
		secureApi::VirtualFree(SysProcess,0, MEM_RELEASE);
		return 0;
	}

	CurrProcess = ( SYSTEM_PROCESS_INFORMATION * ) &SysProcess[0];
	while( CurrProcess->NextEntryDelta && ( DWORD ) CurrProcess->ProcessId != ProcessId )
	{
		CurrProcess = ( SYSTEM_PROCESS_INFORMATION * ) ( ( DWORD ) CurrProcess + ( DWORD ) CurrProcess->NextEntryDelta );
	}

	for( unsigned int i = 0; i < CurrProcess->ThreadCount; i++ )
	{
		ThreadHandle = secureApi::OpenThread( 0x48, FALSE, ( DWORD ) CurrProcess->Threads[i].ClientId.UniqueThread );
		ThreadStartAddress = GetThreadStartAddress( ThreadHandle );

		
		secureApi::GetThreadContext( ThreadHandle, &ctx );


		#ifdef _M_IX86
			ThreadIP = ctx.Eip;
		#elif _M_IX64
			ThreadIP = ctx.Rip;
		#endif
		


		if( ThreadStartAddress > CODEEND || ThreadStartAddress < CODEBEGIN )
		{
			BadThreadCount++;
		}
		else if( ( ThreadIP > CODEEND || ThreadIP < CODEBEGIN ) && ( ThreadIP > MODEND || ThreadIP < MODBEGIN ) )
		{
			BadThreadCount++;
		}
		

		secureApi::CloseHandle( ThreadHandle );
	}
	secureApi::VirtualFree(SysProcess,0, MEM_RELEASE);
	return 0;
	return( BadThreadCount );
}

DWORD EnumerateFunctions( )
{
	DWORD BadFunctionCount = 0;
	const PVOID ApiFunctions[API_FXN_COUNT] = { API_FUNCTIONS };
	const UCHAR PrologueCode[] = { PROLOGUE_CODE };

	for( unsigned int i = 0; i < API_FXN_COUNT; i++ )
	{
		if( memcmp( ApiFunctions[i], PrologueCode, PROLOGUE_COUNT ) )
			BadFunctionCount++;
	}
	return( BadFunctionCount );
}

DWORD EnumerateModules( )
{
	PLIST_ENTRY pebModuleHeader, ModuleLoop;
	PLDR_MODULE lclModule;
	PPEB_LDR_DATA pebModuleLdr;
	DWORD BadModuleCount = 0;

	#if _M_IX86
		pebModuleLdr = ( PPEB_LDR_DATA ) *( ( DWORD_PTR * ) __readfsdword( 0x30 ) + 12 / sizeof( DWORD_PTR ) );
	#elif _M_X64
		pebModuleLdr = ( PPEB_LDR_DATA ) *( ( DWORD_PTR * ) __readgsqword( 0x60 ) + 24 / sizeof( DWORD_PTR ) );
	#endif

	pebModuleHeader = ( PLIST_ENTRY ) &pebModuleLdr->InLoadOrderModuleList;

	lclModule = ( PLDR_MODULE ) pebModuleHeader->Flink;
	ModuleLoop = pebModuleHeader->Flink;
	while( pebModuleHeader != ModuleLoop)
	{
		if( ( ( DWORD_PTR ) lclModule->EntryPoint > CODEEND || ( DWORD_PTR ) lclModule->EntryPoint < CODEBEGIN ) && \
			( ( DWORD_PTR ) lclModule->EntryPoint < MODBEGIN || ( DWORD_PTR ) lclModule->EntryPoint > MODEND ) )
		{
				BadModuleCount++;
		}

		lclModule = ( PLDR_MODULE ) ModuleLoop->Flink;
		ModuleLoop = ModuleLoop->Flink;
	}
	return( BadModuleCount );
}

DWORD EnumerateRegions( )
{
	DWORD BadSegmentCount = 0;
	MEMORY_BASIC_INFORMATION pe, text, rdata, data, rsrc, reloc;

	secureApi::VirtualQuery( ( void * ) 0x00400000, &pe, sizeof( MEMORY_BASIC_INFORMATION ) );
	secureApi::VirtualQuery( ( void * ) 0x00401000, &text, sizeof( MEMORY_BASIC_INFORMATION ) );
	secureApi::VirtualQuery( ( void * ) 0x00402000, &rdata, sizeof( MEMORY_BASIC_INFORMATION ) );
	secureApi::VirtualQuery( ( void * ) 0x00403000, &data, sizeof( MEMORY_BASIC_INFORMATION ) );
	secureApi::VirtualQuery( ( void * ) 0x00405000, &rsrc, sizeof( MEMORY_BASIC_INFORMATION ) );
	secureApi::VirtualQuery( ( void * ) 0x00406000, &reloc, sizeof( MEMORY_BASIC_INFORMATION ) );

	if( pe.Protect != 0x2 )
		BadSegmentCount++;

	if( text.Protect != 0x20 )
		BadSegmentCount++;

	if( rdata.Protect != 0x2 )
		BadSegmentCount++;

	if( data.Protect != 0x8 )
		BadSegmentCount++;

	if( rsrc.Protect != 0x2 )
		BadSegmentCount++;

	if( reloc.Protect != 0x2 )
		BadSegmentCount++;

	return( BadSegmentCount );
}

void main( )
{
	if( EnumerateThreads( secureApi::GetCurrentProcessId( ) ) != 0 )
		secureApi::ExitProcess( -1 );

	if( EnumerateFunctions( ) != 0 )
		secureApi::ExitProcess( -2 );

	if( EnumerateModules( ) != 0 )
		secureApi::ExitProcess( -3 );

	if( EnumerateRegions( ) != 0 )
		secureApi::ExitProcess( -4 );

	secureApi::ExitProcess( 0 );
}